/*********************************************
 *  File:     #Include inc_Cmd.ahk
 *  Author:   Kalle Koseck
 *  License:  GPL / GNU General Public License
 *  Date:     2009-06-03
 *  Revision: 
 *
 *********************************************
 */


 
/******************************************************
 *  Sub:      Cmd_WinRenameTitle
 *  Author:   Kalle Koseck
 *  License:  GPL / GNU General Public License
 *  Date:     2009-05-27
 *  Revision: 
 *  
 *  Call:
 *  
 *  WinSize2 WinRenameTitle "Old_NameOfWindow" "New_NameOfWindow" 
 *  
 *******************************************************
 */
Cmd_WinRenameTitle( Title_Old, Title_New )
{

	Global
	
	If ( P0_NoParams <> 3 )
	{
		MsgBox WinSize2 (command: "%P1_Cmd%") `r`n`r`nparameters expected: 3 `r`nbut You sent: %NoOfParams%
		ExitApp_Code := 11
		Return
	}

	; Set Timeout to xx sec.

	SetWinDelay, -1
	DetectHiddenWindows, Off

	; 1: A window's title must start with the specified WinTitle to be a match.
	; 2: A window's title can contain WinTitle anywhere inside it to be a match. 
	; 3: A window's title must exactly match WinTitle to be a match.
	SetTitleMatchMode, 1

	; timeout: xx sec.
	TimeoutSec = 10
	Tooltip ... waiting for window to be started: %Title_Old%
	WinWait, %Title_Old%,, %TimeoutSec%

	ExitApp_Code := ErrorLevel
	If ( ErrorLevel = 0 )
	{
		Tooltip The Window is started: %Title_Old%
		WinActivate  ; Uses the last found window
		
		; WinGet, ActName, ProcessName
		; Msgbox ActName: %ActName%

		; dies geht aber nur bei Programmen, die die Titelzeile nicht aktiv verndern
		; also z.B. nicht bei IrfanView oder ev. Notepad
		WinSetTitle, %Title_New%
	}

	Else
	{
		Tooltip WinSize2: The Window was not started `r`n(timed out after %TimeoutSec% sec.): `r`n`r`n"%Title_Old%"
		Sleep 5000
	}

	Return

}

