/*************************************************************************
 *
 *  #Include inc_IniReadWrite_User.AHK
 *
 *  Datum: 2005-05-06 14:27
 *  Autor: Magra19
 *  Typ:   Method
 *************************************************************************
 *
 *  this has to be a function declaration for use in #Include statement:
 */
mIniWrite_All_User()
{
	Global  ; don't forget: necessary to access global variables
	;
	; detect changes here (If ( Var <> Var_Old) ... IniFile_Write_All := True)
	; or in your main program.
	;
	; !!   Please :
	; !!   DO NOT reset IniFile_Write_All before leaving this method.
	; !!   The calling method needs this variable and will reset it.
	;
	If ! IniFile_Write_All
		Return

	; change the following lines to the variables you want to save !!!

	; ------------------------------------------------------------------------
	; [Settings]

	; IniDelete, %IniFile_PathFile_SaveINI%, Settings   ; also deletes possible comments !!

	IniWrite, %A_Now%, %IniFile_PathFile_SaveINI%, Settings, Date  ; only for documentation
	IniWrite, %vPath_StarsData1%, %IniFile_PathFile_SaveINI%, Settings, Path_StarsData
	IniWrite, %UsedList%, %IniFile_PathFile_SaveINI%, Settings, UsedList
	If ( CurrText <> "" )
		IniWrite, %CurrText%, %IniFile_PathFile_SaveINI%, Settings, CurrText

	; X and Y: blank if hidden
	If ( (GuiWindowX <> "") and (GuiWindowX > 10 ) )
		IniWrite, %GuiWindowX%, %IniFile_PathFile_SaveINI%, Settings, GuiWindowX

	If ( (GuiWindowY <> "") and (GuiWindowY > 10 ) )
		IniWrite, %GuiWindowY%, %IniFile_PathFile_SaveINI%, Settings, GuiWindowY

	IniWrite, %GuiWindowWidth%, %IniFile_PathFile_SaveINI%, Settings, GuiWindowWidth
	IniWrite, %GuiWindowHeight%, %IniFile_PathFile_SaveINI%, Settings, GuiWindowHeight

	; ------------------------------------------------------------------------
	; [WinSize]

	IniWrite, %AW_Control%, %IniFile_PathFile_SaveINI%, WinSize, AW_Control
	Loop, %AWNr_CntEntries%
	{
		AWNr_Name	  = AWNr_%A_Index%
		AWNr_Element := AWNr_%A_Index%
		IniWrite, %AWNr_Element%, %IniFile_PathFile_SaveINI%, WinSize, %AWNr_Name%
 		; Tooltip IniWrite: %AWNr_Name%: %AWNr_Element%
		; Sleep 2000
	}

	If ( vTooltip )
		Tooltip mIniWrite_All_User: has been written

Return
}
;
;***************************************************************************
;
mIniRead_All_User()
{
	Global

	; ------------------------------------------------------------------------
	; [Settings]

	IniRead, UsedList, %IniFile_PathFile_SaveINI%, Settings, UsedList
	IniRead, vPath_StarsData1, %IniFile_PathFile_SaveINI%, Settings, Path_StarsData
	If ( vPath_StarsData1 <> "" )
		If vPath_StarsData1 = ERROR
			vPath_StarsData1 = D:\StarsData\Root\UserData\
		vPath_StarsData = %vPath_StarsData1%

	IniRead, CurrText, %IniFile_PathFile_SaveINI%, Settings, CurrText
	IniRead, GuiWindowX, %IniFile_PathFile_SaveINI%, Settings, GuiWindowX
	IniRead, GuiWindowY, %IniFile_PathFile_SaveINI%, Settings, GuiWindowY
	IniRead, GuiWindowWidth, %IniFile_PathFile_SaveINI%, Settings, GuiWindowWidth
	IniRead, GuiWindowHeight, %IniFile_PathFile_SaveINI%, Settings, GuiWindowHeight

	IfEqual, UsedList, ERROR
		UsedList =

	GuiWindowXOld := GuiWindowX
	GuiWindowYOld := GuiWindowY
	GuiWindowWidthOld := GuiWindowWidth
	GuiWindowHeightOld := GuiWindowHeight

	; ------------------------------------------------------------------------
	; [WinSize]

	AW_Control_Old = %AW_Control%
	IniRead, AW_Control, %IniFile_PathFile_SaveINI%, WinSize, AW_Control
	If ( ! AW_Control or AW_Control = "ERROR" )   ; Blank oder ERROR
		vCtrl_Alt_Y_Hotkey = ^!Y
	Else
		vCtrl_Alt_Y_Hotkey = %AW_Control%
	If ( 	AW_Control_Old <> AW_Control )   ; wenn was geaendert wurde
		mCtrl_Alt_Y_Init( %AW_Control%, %vCtrl_Alt_Y_Time% )

	If ( AWNr_CntEntries <> 0 )
	{
		Nr = 0
		AWNr_CntEntries = 0
		Loop
		{
			AWNr_Name		= AWNr_%A_Index%
			AWNr_Element	:= AWNr_%A_Index%
			IniRead, AWNr_Element, %IniFile_PathFile_SaveINI%, WinSize, %AWNr_Name%
			If ( AWNr_Element = "ERROR" )
				Break
			If ( AWNr_Element <> "" )
			{
				Nr += 1
				AWNr_Name = AWNr_%Nr%
				AWNr_%Nr% = %AWNr_Element%
				AWNr__GID_%Index% := 0

				StringSplit, AWNr_Array_, AWNr_%A_Index% , |, ,

				If ( AWNr_Array_1 = "" )
					Nr -= 1
				Else
					AWNr_CntEntries := Nr
				Tooltip IniRead: %AWNr_CntEntries% | %AWNr_Name%: `n%AWNr_Element%
				Sleep 2000
			}
		}
	}

	If ( vTooltip )
		Tooltip mIniRead_All_User has been read

Return
}
/*
 *  END of #Include inc_IniReadWrite_User.AHK
 ***************************************************************************
 */

