/**************************************************************************
 *  #Include inc_MenuTray.ahk
 *
 *  Author:   Kalle Koseck
 *  License:  GPL / GNU General Public License
 *  Date:     2008-10-14
 *  Revision: 2009-06-10  Edit "FullScreen"
 *
 ***************************************************************************
 */
mMenuTrayIcon()
{
	Global

	; msgbox inc_MenuTray.ahk File_MenuTray_Icon "%File_MenuTray_Icon%" "%vMenuTrayIcon_Show%"
	If ( vMenuTrayIcon_Show = 0 )
	{
		Menu, Tray, NoIcon             ; no icon visible
		/*
		Tooltip Icon NOT VISIBLE
		sleep 3000
		*/
	}
	Else
	{
		Menu, Tray, Icon               ; unhide the icon
		If ( vWinSize2_Not_Active <= 0 )
		{
			Menu, Tray, Icon, %File_MenuTray_Icon%  ; change to new icon
			; msgbox mMenuTrayIcon yes: %File_MenuTray_Icon%
		}
		Else
		{
			Menu, Tray, Icon, %File_MenuTray_NoIcon%
			; msgbox mMenuTrayIcon no: %File_MenuTray_NoIcon%
		}
			
	}
}


mMenuTray()
{
	Global
	
	vWinSize2_Not_Active_Int := vWinSize2_Not_Active
	
	File_MenuTray_Icon =%vProgram_NNam%.ico
	File_MenuTray_NoIcon =%vProgram_NNam%_Disable.ico
	; msgbox "%vProgram_NNam%"  File_MenuTray_Icon "%File_MenuTray_Icon%"
	
	Message := Message_Get( 1052 )  ; (1052) Special Parameters
	
	;=================================
	Menu, Tray, NoDefault
	Menu, Tray, DeleteAll
	If ( DesktopIcon_Tray_Exist = 1 )
		Menu, DesktopIcon, Delete
	;=================================
	
	If ( vProgramExt = "EXE" )
		Menu, Tray, NoStandard
	Else
		Menu, Tray, Add

	Menu, Tray, Add 
	Menu, Tray, Add, % Message_Get(1069) , Tray_Last_Add_Overwr        ;%; (1069) Last window: Add/Overwrite Entry
	Menu, Tray, Add, % Message_Get(1070) , Tray_Last_Delete            ;%; (1070) Last window: Delete Entry
	Menu, Tray, Add 
	
	;  define Sub-Menu first, then use the name in the Menu
	Menu, DesktopIcon, Add, % Message_Get(1137) , Tray_Position_Save      ;%; (1137) Save icon positions
	Menu, DesktopIcon, Add, % Message_Get(1138) , Tray_Position_Restore   ;%; (1138) Restore icon positions
	Menu, DesktopIcon, Add, % Message_Get(1139) , Tray_Position_Change    ;%; (1139) Check for changed icon positions
	DesktopIcon_Tray_Exist := 1
	Menu, Tray, Add, % Message_Get(1144) , :DesktopIcon                ;%; (1144) Desktop Icon Positions
	
	Menu, Tray, Add 
	Menu, Tray, Add, % Message_Get(1176) , Tray_Explorer_Magrasoft     ;%; (1176) Explorer Magrasoft-directory
	Menu, Tray, Add, % Message_Get(1005) , Tray_Edit_INI_File          ;%; (1005) Edit INI-File
	Menu, Tray, Add, % Message_Get(1096) , Tray_Edit_FullScreen_File   ;%; (1096) Edit "FullScreen"
	Menu, Tray, Add, % Message_Get(1004) , Tray_HideIcon               ;%; (1004) Hide Icon

	Tray_Icon_Disable_Name := Message_Get(1177)                        ;%; (1177) WinSize2 deactivated
	If ( vWinSize2_Not_Active <> -1 )
	Menu, Tray, Add, %Tray_Icon_Disable_Name% , Tray_Icon_Disable 

	Menu, Tray, Add,   % Message         , Tray_Parameter              ;%; (1052) Special Parameters
	Menu, Tray, Add, % Message_Get(1060) , Tray_Short_Info             ;%; (1060) Show short information
	Menu, Tray, Default, %Message%
	Message := Message_Get(1044) "  " vVersion
	Menu, Tray, Add, % Message_Get(1044) , Tray_Exit                  ;%; (1044) Exit
	; Menu, Tray, Add 
	
	GoSub Tray_Icon_Disable_SetTray
	Return
}

Tray_Last_Add_Overwr:
	mCtrl_Alt_Y_And_Action( -1 )
	Return

Tray_Last_Delete:
	mCtrl_Alt_Y_And_Action( -2 )
	Return

Tray_Position_Save:
	mDesktopIconSave( )
	Return

Tray_Position_Restore:
	mDesktopIconRestore( )
	Return

Tray_Position_Change:
	mDesktopIconChanged( )
	Return

Tray_Explorer_Magrasoft:
	Run WS2_Explorer.cmd "%IniFile_Path%" , , min
	Return

Tray_Edit_INI_File:
	Run WS2_Edit.cmd "%IniFile_PathFile_SaveINI%" , , min
	; Run Notepad %IniFile_PathFile_SaveINI%
	Return

Tray_Edit_FullScreen_File:
	RunWait WS2_Edit.cmd "%IniFile_PathFile_FullScreen%" , , min
	mFullScreen_Read()
	Return
	
Tray_HideIcon:
	vMenuTrayIcon_Show = 0
	mMenuTrayIcon()
	Return

Tray_Icon_Disable:

	If ( vWinSize2_Not_Active_Int = 0 )
		vWinSize2_Not_Active_Int := 1
	Else
		vWinSize2_Not_Active_Int := 0

	GoSub Tray_Icon_Disable_SetTray
	Return

Tray_Icon_Disable_SetTray:

	If ( vWinSize2_Not_Active <> vWinSize2_Not_Active_Int )
	{
		mLogFile_Write( 2, "***** WinSize2 deactivated ***** " vWinSize2_Not_Active_Int )
	}
		
	vWinSize2_Not_Active := vWinSize2_Not_Active_Int
	mMenuTrayIcon()
	Gosub Tray_Icon_Disable_Check
	Return

Tray_Icon_Disable_Check:
	Tray_Icon_Disable_Name := Message_Get(1177)                        ;%; (1177) WinSize2 deactivated
	If ( Tray_Icon_Disable_Name = "" )
		Tray_Icon_Disable_Name := "*deactivated*"
	If ( vWinSize2_Not_Active = 0 )
	{
		mLogFile_Write( 2, "Menu, Tray, UnCheck " Tray_Icon_Disable_Name )
		Menu, Tray, UnCheck , %Tray_Icon_Disable_Name%
	}
	Else
		If ( vWinSize2_Not_Active = 1 )
		{
			mLogFile_Write( 2, "Menu, Tray, Check " Tray_Icon_Disable_Name )
			Menu, Tray, Check , %Tray_Icon_Disable_Name%
		}
	

	Return

Tray_Parameter:
	mCtrl_Alt_Y_And_Action( 3 )
	Return

Tray_Short_Info:
	Run %A_ScriptDir%\ShortGuide\%vLanguage_NameShort%\index.html
	Return

Tray_Exit:
	ExitApp
/*
 *************************************************************************
 *  Sub: mTray_Icon_Disable
 */
mTray_Icon_Disable_SetTray()
{
	Global

	; if structures do not exist till now: create those
	If ( DesktopIcon_Tray_Exist <> 1 )
		mMenuTray()

	GoSub Tray_Icon_Disable_SetTray
}

/*
 *************************************************************************
 */
