; #SingleInstance
; WinGetPos , AW_X, AW_Y, AW_Width, AW_Height, Program Manager 
; msgbox % AW_X "  " AW_Y "  " AW_Width "  " AW_Height "   Program Manager "

Stack_Test()


/*
 *************************************************************************
 *  File:     inc_Stack.ahk
 *  Author:   Kalle Koseck
 *  License:  GPL / GNU General Public License
 *  Date:     2009-12-02
 *  Revision: 
 *            
 *  - Stack_Push      Push variables to a stack
 *  - Stack_Pop       Pop from a stack
 *  - Stack_DelName   Delete contents by name
 *  - Stack_List      List contents of a stack
 *  - Stack_Entries   determine how many elements are on a stack
 *  - 
 *  
 *************************************************************************
 *  push to stack
 */
Stack_Push( Stack_Name, Stack_PushVar )
{
	Global
	
	StackPush_CntElem := %Stack_Name%_CntElem
	StackPush_CntLoad := %Stack_Name%_CntLoad

	If ( StackPush_CntElem = "" )
		StackPush_CntElem := 0
	If ( StackPush_CntLoad = "" )
		StackPush_CntLoad := 0

	StackPush_CntElem += 1
	%Stack_Name%_CntElem := StackPush_CntElem
	StackPush_CntLoad += 1
	%Stack_Name%_CntLoad = StackPush_CntLoad
	
	%Stack_Name%_Name = %Stack_Name%_%StackPush_CntElem%
	%Stack_Name%_%StackPush_CntElem%_Cont := Stack_PushVar
	%Stack_Name%_%StackPush_CntElem%_Load := 1
	
	%Stack_Name%_CntElem := StackPush_CntElem

	Stack_NameStr = %Stack_Name%
	Stack_Entries( Stack_NameStr )

	Stack_NameStr = %Stack_Name%
	LogText := Stack_List( Stack_NameStr )
	LogText .= "Stack_Push :" Stack_PushVar ":  " LogText
	; mLogFile_Write( LogText )
	; Listvars
	; MsgBox Stack_Push  %Stack_Name%  %Stack_PushVar%

Return
}

/*
 *************************************************************************
 *  pop from stack
 */
Stack_Pop( Stack_Name )
{
	Global
	
	;If ( %Stack_Name%_OnOff = 0 )
	;	Return

	StackPop_CntElem := %Stack_Name%_CntElem
	StackPop_CntLoad := %Stack_Name%_CntLoad

	If ( StackPop_CntElem = "" )
		StackPop_CntElem := 0
	If ( StackPop_CntLoad = "" )
		StackPop_CntLoad := 0

	StackPop_Nr := StackPop_CntElem
	StackPop_Var := 
	PopText := "Stack_Pop from :" Stack_Name ":  `n"

	While , StackPop_Nr >= 1
	{
		Pop_Load := %Stack_Name%_%StackPop_Nr%_Load
		PopText .= StackPop_Nr " [" Pop_Load "] :"
		If ( %Stack_Name%_%StackPop_Nr%_Load = 1 )
		{
			%Stack_Name%_Name = %Stack_Name%_%StackPop_Nr%
			StackPop_Var := %Stack_Name%_%StackPop_Nr%_Cont
			PopText .= StackPop_Var ": "
			%Stack_Name%_%StackPop_Nr%_Load := 0
			; 1 less on stack
			StackPop_CntLoad -= 1   
			; if the poped is top of the stack:
			If ( StackPop_Nr = StackPop_CntElem )
			{
				StackPop_CntElem -= 1
			}
			StackPop_Nr := 0
		}
		PopText .= "`n"

		StackPop_Nr -= 1
	}
	; --- nothing left on the stack: no more elements
	If ( StackPop_CntLoad <= 0 )
	{
		StackPop_CntLoad := 0
		StackPop_CntElem := 0
	}

	%Stack_Name%_CntElem := StackPop_CntElem
	%Stack_Name%_CntLoad := StackPop_CntLoad

	PopText .= "Var=" StackPop_Var "`n"
	Stack_NameStr = %Stack_Name%
	LogText := Stack_List( Stack_NameStr )
	LogText .= "Stack_Pop :" StackPop_Var ":  " LogText
	; mLogFile_Write( PopText )
	; MsgBox Stack_Pop  %Stack_Name%  %StackPop_Var%  %StackPop_CntElem%  %StackPop_CntLoad%
	; Listvars
	; MsgBox Stack_Pop  :%StackPop_Var%:  %PopText% 


Return StackPop_Var
}

/*
 *************************************************************************
 *  set semaphore
 */
Stack_OnOff( Stack_Name, OnOff )
{
	Global
	
	%Stack_Name%_OnOff := OnOff
	
Return
}

/*
 *************************************************************************
 *  delete name on stack
 */
Stack_DelName( Stack_Name, VarDelete )
{
	Global
	
	StackDelN_CntElem := %Stack_Name%_CntElem
	StackDelN_CntLoad := %Stack_Name%_CntLoad

	If ( StackDelN_CntElem = "" )
		StackDelN_CntElem := 0
	If ( StackDelN_CntLoad = "" )
		StackDelN_CntLoad := 0

	StackDelN_Nr := StackDelN_CntElem
	StackDelN_Var := 
	StackDelN_Return := 0

	While , StackDelN_Nr >= 1
	{
		If ( %Stack_Name%_%StackDelN_Nr%_Load = 1 )
		{
			StackDelN_Var := %Stack_Name%_%StackDelN_Nr%_Cont
			; --- the searched var name
			If ( StackDelN_Var = VarDelete )
			{
				%Stack_Name%_%StackDelN_Nr%_Load := 0
				; %Stack_Name%_%StackDelN_Nr%_Cont := 
				StackDelN_Return := StackDelN_Nr

				
				; --- 1 less on stack
				StackDelN_CntLoad -= 1
				
				; --- if the poped is top of the stack:
				If ( StackDelN_Nr = StackDelN_CntElem )
				{
					StackDelN_CntElem -= 1
				}
				StackDelN_Nr := 0
			}
		}

		StackDelN_Nr -= 1
	}

	; --- nothing left on the stack: no more elements
	If ( StackDelN_CntLoad <= 0 )
	{
		StackDelN_CntLoad := 0
		StackDelN_CntElem := 0
	}

	%Stack_Name%_CntElem := StackDelN_CntElem
	%Stack_Name%_CntLoad := StackDelN_CntLoad

	; Listvars
	; MsgBox Stack_DelName  %Stack_Name%  %StackDelN_Var%  %StackDelN_CntElem%  %StackDelN_CntLoad%

Return StackDelN_Return
}

/*
 *************************************************************************
 *  List Stack Contents
 */
Stack_List( Stack_Name )
{
	Global
	
	StackList_CntElem := %Stack_Name%_CntElem
	StackList_CntLoad := %Stack_Name%_CntLoad
	StackList_Nr := 1
	Stack_Text = Stack_List "%Stack_Name%"   Max#:%StackList_CntElem%   #OnStack:%StackList_CntLoad% `n

	While , StackList_Nr <= StackList_CntElem
	{
		%Stack_Name%_Name = %Stack_Name%_%StackList_Nr%
		StackList_Cont := %Stack_Name%_%StackList_Nr%_Cont
		StackList_Load := %Stack_Name%_%StackList_Nr%_Load

		Stack_Text .= StackList_Nr "  [" StackList_Load "]  " StackList_Cont "`n"

		StackList_Nr += 1
	}

Return %Stack_Text%
}

/*
 *************************************************************************
 *  Determine Entries on Stack
    
	Call:

Stack_Entries( "Name_of_StackElement" )
	
	or in a sub:

Stack_Sub( Name )
{
	...
	Name_Str = %Name%
	Stack_Entries( Name_Str )
}
	
 */
Stack_Entries( Stack_Name )
{
	Global
	
	Stack_CntElem := %Stack_Name%_CntElem
	; Stack_NameA = %Stack_Name%_CntElem
	; msgbox "%Stack_Name%"   "%Stack_NameA%"   "%Stack_CntElem%"
	
	StackEntry_Nr := 1
	StackEntry_CntLoad := 0
	Stack_Text = Stack_List "%Stack_Name%" %Stack_CntElem%: `n

	While , StackEntry_Nr <= Stack_CntElem
	{
		%Stack_Name%_Name = %Stack_Name%_%StackEntry_Nr%
		StackEntry_Load := %Stack_Name%_%StackEntry_Nr%_Load
		; msgbox %StackEntry_Nr%:  %Stack_Name%  %Stack_Name%_Name  %StackEntry_Load%
		If ( StackEntry_Load > 0 )
		{
			StackEntry_CntLoad += 1
		}

		StackEntry_Nr += 1
	}

	%Stack_Name%_CntLoad := StackEntry_CntLoad

	; --- nothing left on the stack: no more elements
	If ( StackEntry_CntLoad <= 0 )
	{
		StackEntry_CntLoad := 0
		StackEntry_CntElem := 0
	}

Return %StackEntry_CntLoad%
}

Stack_Test()
{
Global

var01 := 1001
var02 := 1002
var03 := 1003

Stack_Push( "MS" , var01 )
Stack_Push( "MS" , var02 )
Stack_Push( "MS" , var03 )
Zeile := Stack_DelName( "MS" , "1002" )

Text := Stack_List( "MS" )
Listvars
MsgBox %Text%   deleted Line: %Zeile%


var11 := Stack_Pop( "MS" )
var12 := Stack_Pop( "MS" )

Listvars
MsgBox Stack_Test
}