/*********************************************
 *  File:     inc_Update.ahk
 *  Author:   Kalle Koseck
 *  License:  GPL / GNU General Public License
 *  Date:     2008-11-03
 *  Revision: 
 *
 *********************************************
*/



; Loop
{
Update_WinSize2()
}

MsgBox (99) Exit %A_ScriptFullPath%
ExitApp

================================================================

Update_WinSize2()
{
	Global

	;  try every xx sec
	If ( Update_TickCount > A_TickCount )
	{
		; Tooltip inc_Update Return "%Update_TickCount%" "%A_TickCount%" 
		Return
	}

	; next check: in xx msec.
	Update_TickCount := A_TickCount + 3000   ; should be: 30000


	; Tooltip inc_Update INIT
	Update_OrgPath = %A_WorkingDir%\
	Update_OrgFile = %vProgram_NNam%%vProgram_NExt%
	
	Update_OrgPath := mSlashAtTheEnd( Update_OrgPath )
	Update_UpdPath := mSlashAtTheEnd( Update_UpdPath )
	; Tooltip mSlashAtTheEnd %Update_OrgPath%   %Update_UpdPath%

	; containing the updated files
	; 
	Update_UpdFile = %vProgram_NNam%_UPDATE%vProgram_NExt%
	; MsgBox (0) Start Script %A_ScriptFullPath%    %Update_UpdFile%

	;=======================================================================

	/*
	Update_OrgPath = ..\Update_Org\
	Update_OrgFile = inc_Update.ahk

	; containing the updated files
	; Update_UpdPath = ..\Update\
	Update_UpdFile = inc_Update_Update.ahk
	
	;=======================================================================

	Update_OrgPath = WinSize2\
	Update_OrgFile = WinSize2.exe

	; containing the updated files
	; Update_UpdPath = WinSize2_Update\
	Update_UpdFile = WinSize2_Update.exe
	*/

	;=======================================================================

	;  --- Upd: file from Update directory
	;  --- OUp: _Update-file in the Original directory
	;  --- Org: Original-file in the Original directory
	Update_UpdPathFile = %Update_UpdPath%%Update_UpdFile%
	Update_OUpPathFile = %Update_OrgPath%%Update_UpdFile%
	Update_OrgPathFile = %Update_OrgPath%%Update_OrgFile%
	
	If ( Update_UpdPath = "" )
		Update_UpdPathFile = 

	;=======================================================================
	/*
	FileGetSize, Update_UpdFile_Size , %Update_UpdPathFile%
	FileGetSize, Update_OUpFile_Size , %Update_OUpPathFile%
	FileGetSize, Update_OrgFile_Size , %Update_OrgPathFile%
	*/

	FileGetTime, Update_UpdFile_Time , %Update_UpdPathFile%
	FileGetTime, Update_OUpFile_Time , %Update_OUpPathFile%
	FileGetTime, Update_OrgFile_Time , %Update_OrgPathFile%

/* 
If ( Tooltip_Show_Store )
{
TTL := 003
TTLMsg := ATime() ":  (" TTL ") FileGetTime NoUpd:" vProgram_NUpd "   " Update_UpdPathFile ":" Update_UpdFile_Time "   " Update_UpdFile ":" Update_OUpFile_Time "   " Update_OrgFile ":" Update_OrgFile_Time
Tooltip_%TTL% := TTLMsg
If ( Tooltip_Show_Tip = 1 )
{
CoordMode, ToolTip, Screen
Tooltip %TTLMsg%  ,TTX , TTL*TTM, TTL+TTP ;%
CoordMode, ToolTip, Relative
}  }
 */
	;  AHKs can be overwritten during run of program
	If ( vProgram_NExt = ".AHK" )
		Return

	;===================================================================
	; STEP 3: running: the _Org-file
	;         update complete; delete _OUp-file
	;         _Upd and _Org-file are identical: no further update done
	
	; MsgBox (1) Update_OUpFile_Time "%Update_OUpPathFile%" "%Update_OUpFile_Time%"   Update_OrgFile_Time "%Update_OrgPathFile%" "%Update_OrgFile_Time%"
	If ( Update_OUpFile_Time <> ""
		AND Update_OUpFile_Time = Update_OrgFile_Time 
		AND vProgram_NUpd = 0 )
	{
		; MsgBox (2) FileDelete %Update_OUpPathFile%
		FileDelete, %Update_OUpPathFile%
	}
	
	;===================================================================
	; STEP 2a: running: the _OUp-file
	;         in _Org dir: _OUpd-file is different from _Org-file
	;         copy _OUp-file over _Org-file
	;         switch over to the _Org-file
	
	Else If ( Update_OUpFile_Time <> ""
		AND Update_OUpFile_Time <> Update_OrgFile_Time )
	{
		;  copy _OrgUpd over _Org
		;  and switch back to _Org
		FileCopy, %Update_OUpPathFile%, %Update_OrgPathFile%, 1
		Error = %ErrorLevel%
		; MsgBox (3) File OUp to Org: "%Update_OUpPathFile%"  "%Update_OrgPathFile%"  "%Error%"

		;  and copy the sub-Dirs
		FileCopyDir, %Update_UpdPath%\Source,        %Update_OrgPath%\Source      , 1
		FileCopyDir, %Update_UpdPath%\ShortGuide,    %Update_OrgPath%\ShortGuide  , 1
		; msgbox FileCopy-SubDir %Update_UpdPath% to %Update_OrgPath%: Source + ShortGuide
		If ( Error = 0 )
		{
			; MsgBox (91-2a) Run "%Update_OrgPathFile%"  UPDATE
			Run, "%Update_OrgPathFile%"  /UPDATE
			; MsgBox (91a-2a) Exit %A_ScriptFullPath%
			ExitApp
		}
		Else
		{
			; MsgBox (92-2a) Run %Update_OUpPathFile% UPDATE
			Run "%Update_OUpPathFile%" /UPDATE
			; MsgBox (92a-2a) Exit %A_ScriptFullPath%
			ExitApp
		}
		
	}
	
	;===================================================================
	; STEP 2b: running: the _OUp-file
	;         another program already copied _OUp-file over _Org-file
	;         in _Org dir: _OUpd-file is the same as _Org-file
	;         switch over to the _Org-file
	
	Else If ( Update_OUpFile_Time <> ""
		AND Update_OUpFile_Time = Update_OrgFile_Time )
	{
		; MsgBox (93-2b) Run "%Update_OrgPathFile%"  UPDATE
		Run, "%Update_OrgPathFile%"  /UPDATE
		; MsgBox (93a-2b) Exit %A_ScriptFullPath%
		ExitApp
		
	}

	;===================================================================
	; STEP 1: running: the old _Org-file
	;         Copy _Upd-dir over _Org
	;         _Upd-file is copied to / over _OUp-file
	;         but _Org is still the same
	;         switch (Run) over the _OUp-file
	
	; MsgBox (6) Update_UpdFile "%Update_UpdPathFile%" "%Update_UpdFile_Time%"   Update_OrgFile_Time "%Update_OrgPathFile%" "%Update_OrgFile_Time%"
	If ( Update_UpdFile_Time <> ""
		AND Update_UpdFile_Time <> Update_OrgFile_Time )
	{
		; Copy Upd over Org
		FileDelete,                        %Update_OrgPath%\*.ver
		FileCopy, %Update_UpdPath%\*.*,    %Update_OrgPath%, 1
		/*
		FileCopy, %Update_UpdPath%\*.msg,  %Update_OrgPath%, 1
		FileCopy, %Update_UpdPath%\*.ico,  %Update_OrgPath%, 1
		FileCopy, %Update_UpdPath%\*.jpg,  %Update_OrgPath%, 1
		FileCopy, %Update_UpdPath%\*.pdf,  %Update_OrgPath%, 1
		FileCopy, %Update_UpdPath%\*.html, %Update_OrgPath%, 1
		FileCopy, %Update_UpdPath%\*.ver,  %Update_OrgPath%, 1
		FileCopy, %Update_UpdPath%\WinSize2_Update.exe, %Update_OrgPath%, 1
		*/
		; does not work: stopps execution when error is detected
		; FileCopyDir, %Update_UpdPath%, %Update_OrgPath%, 1
		; MsgBox (7) FileCopy Upd to Org: "%Update_UpdPath%"  "%Update_OrgPath%"  "%ErrorLevel%"
		Sleep 2000
		
		; Copy _Update over Original
		If ( FileExist( Update_OUpPathFile ) )
		{
			; if copy end with error, switch to _Upd file
			; (and copy later _Upd to _Org)
			; MsgBox (94) Run %Update_OUpPathFile% UPDATE
			Run "%Update_OUpPathFile%" /UPDATE
			; MsgBox (94a) Exit %A_ScriptFullPath%
			ExitApp
		}

	}

	; Tooltip ENDE Inc_Update %Update_OrgFile_Time%
	Return
}