/*********************************************
 *  File:     inc_WinSize2_Parameter.ahk
 *  Author:   Kalle Koseck
 *  License:  GPL / GNU General Public License
 *  Date:     2008-09-30
 *  Revision: 2009-06-23
 *
 *********************************************
 *
 *  watch the **NEW**
 *

Calling Sequence:

vGUI_TERMINATE_NOW := 0
WinSize2_Parameter()
Loop
{
	If ( vGUI_TERMINATE_NOW > 10 )
		Break
	tooltip WaitGuiEnd: vGUI_TERMINATE_NOW %vGUI_TERMINATE_NOW%
	Sleep 200
}

MsgBox WinSizeGui_Parameter.ahk ExitApp(%vGUI_TERMINATE_NOW%)  %split_Title% / %split_X_Coord% / %split_Y_Coord% / %split_Width% / %split_Height%  
ExitApp

#Include inc_WinSize2_Parameter.ahk
 *
 **************************************************************************
 */
WinSize2_Parameter()
{
	Global
	
	; mListVars()
	mGroup_Sort()

	vGUI_TERMINATE_NOW := -1
	Sort_New := 0
	; --- debug: show the changed button
	Para_ShowButton_Enable := 0
	Para_ShowButton_Text = 
	aaPara_Timer_TimeStart := A_TickCount
	aaPara_Timer_TimeCnt := 0
	; split_MinNormMax_Int = split_MinNormMax
	split_MinNormMax =
	split_Title_Old := split_Title
	split_Title_NrInt_Old := split_Title_NrInt
	FullScreen_Char_changed := 0
	Disable_TickCount_Add := 150
	TextOK_Mark := 0
	Delay_Show_Tooltip_New := Delay_Show_Tooltip
	ColorBackground := 
	ColorControl := 
	ColorBlue := "0xddddFF"
	ColorGreen := "0xddFFdd"
	vWinSize2_Not_Active_Int := vWinSize2_Not_Active

	If ( GuiWindowX = "ERROR" )
		GuiWindowX = 400
	If ( GuiWindowY = "ERROR" )
		GuiWindowY = 110
	; If ( GuiWindowHeight = "ERROR" )
		GuiWindowHeight = 410
	; If ( GuiWindowWidth = "ERROR" )
		GuiWindowWidth  = 815

	 StartWinEntry := WinSize2_Registry( 1 )   ; READ from registry
	/*
	 RegRead StartWinEntry
		, HKEY_LOCAL_MACHINE
		, Software\Microsoft\Windows\CurrentVersion\Run
		, WinSize2
	*/
	 If ( StartWinEntry <> "" )
		StartWinChecked := 1
	Else
		StartWinChecked := 0
	; msgbox StartWinEntry %StartWinEntry%
	StartWinEnabled := 1
	IfInString, vProgram_NNamExt, .AHK
	{
		StartWinChecked := 0
		StartWinEnabled := 0
	}

	;  Check if this file exists:
	;                         "C:\Windows\System32\WinSize2.cmd"
	; Start_WinSize2_PathFile := "E:\_Scratch\_aWS\" vProgram_NNam ".cmd"
	Start_WinSize2_PathFile := A_WinDir "\System32\" vProgram_NNam ".cmd"
	IfExist, %Start_WinSize2_PathFile%
		Start_WinSize2_Every_Dir_Old = 1
	Else
		Start_WinSize2_Every_Dir_Old = 0

	mTitle_Number_Set( Title_NrInt_Last )

	Title_Number_Sort := split_Title_NrAW
	Title_Number_Max := AWNr_CntEntries
	Title_Number_Old = 0
	
	Titles_Sort_Basis_Int := Titles_Sort_Basis
	Titles_Sort_ZA_Int := Titles_Sort_ZA
	Titles_Sort_wComm_Int := Titles_Sort_wComm

	AWNr_Deleted_Ignore := 0
	vCtrl_Alt_Y_Hotkey_Old := vCtrl_Alt_Y_Hotkey

	vLanguage_Nr_Name := vLanguage_INI
	vLanguage_Nr_Name_Old := vLanguage_Nr_Name
	mLang_Select_All_Set()
	GuiControl,, vLang_Select_All , %vLang_Select_All%

	GoSub WinSize2_Parameter_Split
	GoSub mDropDownTitle_Make
	GoSub Para_Timer_FillVar_Start

	FontName := "Tahoma"   ; Verdana
	vMessage_Font := 8
	GoSub Screen_Factor
	
	If ( GuiWindowX < -10000 OR GuiWindowY < -10000 )
	{
		LogText := " Spec Parameter window was X/Y: " GuiWindowX "/" GuiWindowY "; set to 5/5 now"
		mLogFile_Write( 1, LogText )
		GuiWindowX := 5
		GuiWindowY := 5
	}

	;---------------------------------------------------------------
	; Gui, Caption WinSize2 Version - Special Parameters
	;***************************************************************
	;*** (1080)  W I N T I T L E
	;***************************************************************
	GuiCaption := "WinSize2 " vVersion " - " Message_Get(1052)   ; WinSize2 V2.27.01 - Special Parameters
	If ( vWinSize2_Not_Active_Int = 1 )
		GuiCaption .= "  -  " Message_Get(1178)   ;  -  N O T   A C T I V E

	Gui, Font, W600 S15, %FontName%
	; Gui, Add, Text,     xm+100   ym+50    w300 h40                      , Building Page
	Gui, Show, X%GuiWindowX%  Y%GuiWindowY% H%GuiWindowHeight% W%GuiWindowWidth%, % "WinSize2 " ;%; vVersion " - " Message_Get(1052)   ;%; Special Parameters

	;         light grey  very light yellow
	Gui, Color, 0xe6e3c0, 0xFFffF0
	Gui, Color, 0xc0c0b0, 0xFFffF0
	
	GuiWindowHeightUn := GuiWindowHeight - 55

	;***   W I N  T I T L E    F O O T E R :   O K ,  A B O R T
	; ---------- the buttons OK and ABORT at the lower end of the window ----------
	Gui, Font, W700 %FontStd%, %FontName%
	;*** (1024)  OK
	;*** (1022)  Abort
	Gui, Font, W800 %FontMarker%, %FontName%
	Gui, Add, Text, SECTION  x20    y%GuiWindowHeightUn% w60 h30  c0000FF vTextOK Right   ,   ; >>> left of OK
	If ( Tooltip_Show_Store )
	{
	Gui, Font, W1 %FontSmallVS%, %FontName%
	Gui, Add, Button,   xs  yp+5 w60  h20  gButtonDelTooltip     , Del Tooltip
	; Gui, Add, Text,     xs+70  y  w0   h30
	Gui, Font, W600 %FontStd%, %FontName%
	}
	Gui, Font, W600 %FontStd%, %FontName%
	Gui, Add, Button,   xs+65  ys    w90  h30  vButtonOK    gButtonOK     , % Message_Get(1024)   ;%; OK
	Gui, Add, Button,   xp+100 yp    w90  h30  vButtonAbort gButtonAbort  , % Message_Get(1022)   ;%; Abort
	GuiControl, +Default , ButtonAbort
	GuiControl, Enable0 , ButtonOK

	Gui, Font, W700 %FontSmallS%, %FontName%
	Gui, Add, Text,     xp+110 yp       w450 h15      , % vProgram_NExt " " Message_Get(1061)    ;%; .EXE Started from:
	Gui, Add, Text,     xp     yp+15    w450 h15      , %A_ScriptDir%

	; (1104)  INI file stored in: 
	; +1: (1105)  --<User>-- (not used)
	; +2: (1106)  
	; +3: (1107)  
	INIFile_Stored_In := "pers. " IniFile_Save_File_in_Dir
	INIFile_Stored_In := 
		Save_File_in_Dir := 1104 + IniFile_Save_File_in_Dir
	If ( IniFile_Save_File_in_Dir = 2 OR IniFile_Save_File_in_Dir = 3 )
	{
		INIFile_Stored_In := Message_Get(1104) " " Message_Get(Save_File_in_Dir) 
	}

	Gui, Add, Text,     xp     yp+15    w450 h15      , %INIFile_Stored_In%
	Gui, Font, W700 %FontStd%, %FontName%


	Gui, Font, W600 %FontStd%, %FontName%
	; *** (1080)..(1085)  WinTitle|Extras-1|Extras-2|Special|Group|Desktop Icon+Network
	;msgbox  vMessage 01   "%vMessage%"
	TextAllTabs :=      Message_Get(1080)
	TextAllTabs .=  "|" Message_Get(1081)
	TextAllTabs .=  "|" Message_Get(1082)
	TextAllTabs .=  "|" Message_Get(1083)
	TextAllTabs .=  "|" Message_Get(1084)
	TextAllTabs .=  "|" Message_Get(1085)

	WHigh := GuiWindowHeight - 6
	WWidt := GuiWindowWidth - 6
	If ( TabNumber_Open_Last_Tab >= 2 )
		TabNumber_ActTab := TabNumber_Open_Last_Tab - 1
	TabNumber_ActTab_Old := TabNumber_ActTab
	Gui, Add, Tab2, x3 y3 H%WHigh% W%WWidt% vTabNumber_ActTab AltSubmit Choose%TabNumber_ActTab%, %TextAllTabs%
	;msgbox  TextAllTabs 02   %TextAllTabs%  (%m1080%)
	;***************************************************************
	Gui, Font, W600 %FontStd%, %FontName%

	;***   W I N  T I T L E    F O O T E R :   D E L E T E ,  C H A N G E

	; +--------- Groupbox DELETE/CHANGE ---------------------+
	; !                                                      !
	Gui, Add, GroupBox, xm+610  ym+30   w170 h175  SECTION                    , % Message_Get(1025)  ;%;  Delete/Change
	Gui, Add, Button,   xp+10   yp+30   w40 h30                gButtonMinus   , % Message_Get(1026)  ;%;  <<
	Gui, Add, Text,     xp+50   yp+6    w20 h20  vTitle_Number_Sort           , %Title_Number_Sort%
	Gui, Add, Text,     xp+23   yp      w40 h20  vTitle_Number_Max            , /%Title_Number_Max%
	Gui, Add, Button,   xp+35   yp-6    w40 h30                gButtonPlus    , % Message_Get(1027)  ;%;  >>

	Gui, Add, Button,   xs+10   yp+50   w85 h30  vButtonChange gButtonChange  , % Message_Get(1029)  ;%;  Change
	GuiControl, Disable, ButtonChange
	Gui, Add, Button,   xp      yp+40   w85 h30                gButtonDelete  , % Message_Get(1028)  ;%;  Delete

	Gui, Font, W800 %FontMarker%, %FontName%
	Gui, Add, Text,     xp+90   yp-40   w65 h30  vTextChange c0000FF       , ; !!!!!!!
	Gui, Font, W600 %FontStd%, %FontName%


	;***   W I N  T I T L E    W I N D O W

	; +--- Complete window title ----------------------------+
	; !                                                      !
	;*** (1110)  (Complete / **Contained** in) Window Title
	Gui, Add, GroupBox,     xm+00 ym+30  w600 h113 vBoxTitle SECTION               , %BoxTitleText%  ;%;
	;                                             split_Title_NrInt
	Gui, Add, DropDownList, xp+10 yp+20  w580      vsplit_Title_NrInt gDropDownTitle cBlue  AltSubmit ,
	Gui, Add, Edit,         xp    yp     w580 h20  vsplit_Title       gEditTitle cBlue   , %split_Title%
	GuiControl , Hide, split_Title
	
	Gui, Font, W1 %FontSmall%, %FontName%
	; *** (1030)  If changed: The Window Title has to CONTAIN this string
	Gui, Add, Text,     xp     yp+21  w430 h20 vTextContain  SECTION                , % Message_Get(1030) ;%;
	GuiControl , Hide, TextContain
	; *** (1103)  Edit
	Gui, Add, Button,   xp     yp+3   w60  h20 vButtonEdit          gButtonEdit     , % Message_Get(1103)
	; --- Class Name
	Gui, Add, Text,     xp+340 yp-3   w240 h13 Right vsplit_AhkClass_Name_GUI       , %split_AhkClass_Name%
	; *** (1121)  Detection: use Class name
	Gui, Add, Checkbox, xp-60  yp+15  w300 h13 Right vsplit_AhkClass_Used_GUI  gsub_split_AhkClass_Used Checked%split_AhkClass_Used% , % Message_Get(1121) ;%;

	; Gui, Font, W700 %FontSmall%, %FontName%
	; *** (1119)  if sorted: "group:comment// shown before title"
	Gui, Add, Checkbox, xp-230 yp+13  w300 h13 vsplit_Comment_Use_Int  gsub_split_Comment_Use  Checked%split_Comment_Use% , % Message_Get(1119) ;%;
	Gui, Font, W1 %FontSmall%, %FontName%
	; *** (1120)  all
	Gui, Add, Checkbox, xp-50  yp     w50 h13  vTitles_Sort_wComm_Int gsub_Titles_Sort_wComm Checked%Titles_Sort_wComm% , % Message_Get(1120) ;%;
	; *** () Comment text
	Gui, Add, Edit,     xp-0 yp+17  w580 h20 vsplit_Comment_Text_Int  gsub_split_Comment_Text cBlue ,  %split_Comment_Text%
	; !                                                      !
	; +------------------------------------------------------+

	; *** (1064)  Delay for xx msec.
	Gui, Add, Edit,     xs     yp+35  w70  h20  vsplit_Delay_Int   gsub_split_Delay cBlue   , %split_Delay%
	Gui, Add, Text,     xp+85  yp     w400 h20                                , % Message_Get(1064) ;%;


	; +------------------------------------------------------+
	; !                                                      !
	; *** (1020)  X-Coordinate / Y-Coordinate
	;             X-coord = right / left   Y-coord = up / down
	Gui, Font, W600 %FontStd%, %FontName%
	Gui, Add, GroupBox, xm+00  yp+25   w290 h70                                , % Message_Get(1020) ;%;
	Gui, Add, Edit,     xp+10  yp+20 w70  h20  vsplit_X_Coord_Int       gsub_split_X_Coord cBlue , %split_X_Coord%
	Gui, Add, Edit,     xp+80  yp    w70  h20  vsplit_Y_Coord_Int       gsub_split_Y_Coord cBlue , %split_Y_Coord%
	Gui, Font, W1 %FontSmall%, %FontName%
	Gui, Add, Checkbox, xp+80  yp    w70  h20  vsplit_XY_Always_Int     gsub_split_XY_Always Checked%split_XY_Always%, % Message_Get(1065) ;%; "Always"
	Gui, Font, W600 %FontStd%, %FontName%
	; !                                                      !
	; +------------------------------------------------------+

	; +------------------------------------------------------+
	; !                                                      !
	; *** (1021)  Width / Height
	Gui, Add, GroupBox, xm+310 yp-20   w290 h70                                , % Message_Get(1021) ;%;
	Gui, Add, Edit,     xp+10  yp+20 w70  h20  vsplit_Width_Int         gsub_split_Width cBlue  , %split_Width%
	Gui, Add, Edit,     xp+80  yp    w70  h20  vsplit_Height_Int        gsub_split_Height cBlue  , %split_Height%
	Gui, Font, W1 %FontSmall%, %FontName%
	Gui, Add, Checkbox, xp+80  yp    w70  h20  vsplit_WH_Always_Int     gsub_split_WH_Always Checked%split_WH_Always%, % Message_Get(1066) ;%; "Always"
	Gui, Font, W600 %FontStd%, %FontName%

	;*** (1014)  -1: here the actual value of the window is taken
	Gui, Font, W1 %FontSmall%, %FontName%
	Gui, Add, Text,     xm+40  yp+25 w545 h20  Center                        , % Message_Get(1014) ;%;
	; !                                                      !
	; +------------------------------------------------------+

	
	; +--- AlwaysOnTop / Open Window ------------------------+
	; !                                                      !
	Gui, Font, W600 %FontStd%, %FontName%
	Gui, Add, GroupBox,     xm+00   yp+25  w750 h70 SECTION

	; ========== Hidden - Minimized - Normal - Maximized - FullScreen ==========
	Gui, Add, Text,         xs+270  ys+15  w100 h20 vOpenTheWindow Right           ,  ; Open window
	Gui, Font, W700 %FontSmallS%, %FontName%
	Gui, Add, DropDownList, xp+105  yp-3   w200     vsplit_MinNormMax_Int gsub_MinNormMax AltSubmit Choose%split_MinNormMax% cBlue, %tMinNormMax%
	
	; --- {Return}||{Right}|{Left}|... ----------------------------
	AppendReturn_Start := 1201
	AppendReturn_End := AppendReturn_Start
	AppendReturn_Intg := 1
	AppendReturn_String := 
	While , 1
	{
		AppendReturn_String0 := Message_Get( AppendReturn_End )
		If ( AppendReturn_String0 = "---" )
			Break
		AppendReturn_String .= AppendReturn_String0 "|"
		If ( AppendReturn_End = AppendReturn_Start )
			AppendReturn_String .= "|"
		AppendReturn_End += 1
	}
	Gui, Add, DropDownList, xp+205  yp   w85  vAppendReturn_Intg gSubAppendReturn AltSubmit cBlue, %AppendReturn_String%
	Gui, Add, Button,       xp+90  yp   w70  h20  vButtonAppend gButtonAppend     , % Message_Get( 1200 ) ;%; Append
	; -------------------------------------------------------------
	
	;** (1095)  Send char(s):
	Gui, Add, Text        , xs+20   yp+30  w350 h20 vFullScreen_Text Right                , % Message_Get(1095)   ;%;
	Gui, Add, Edit        , xp+355  yp-3   w365 h20 vsplit_FullScr   gSubFullScreen_Char_Change cBlue , %split_FullScr_Sum%
	; -------------------------------------------------------------

	GuiControl, Hide, FullScreen_Text
	GuiControl, Hide, split_FullScr
	GuiControl, Hide, AppendReturn_Intg
	GuiControl, Hide, ButtonAppend
	Gui, Add, Text        , xp-375  yp-25  w0

	; ===== Always on Top =====
	Gui, Font, W600 %FontStd%, %FontName%
	;*** (1047) Always on Top
	Gui, Add, Checkbox, xs+10     ys+10  w260 h20  vsplit_AlwaysOnTop_Int  gsub_split_AlwaysOnTop Checked%split_AlwaysOnTop% , % Message_Get(1047) ;%; Always On Top
	Gui, Font, W1 %FontSmall%, %FontName%
	;% Message_Get(1048)   ;%; applied at once when clicking "OK"
	Gui, Add, Text,     xp+20     yp+18 w260 h15                                , % Message_Get(1048)   ;%; applied at once when clicking "OK"
	; !                                                      !
	; +------------------------------------------------------+



	;***************************************************************
	; *** (1081)  E X T R A S - 1
	Gui, Tab, % Message_Get( 1081 )  ;%;
	;***************************************************************
	Gui, Font, W100 %FontStd%, %FontName%
	Gui, Add, Text,     x50  y25 w0

	; *** (1037)  Language  ? = take default from operating system:
	Gui, Add, Text,         xp+165  yp+25  w500 h20                    , % Message_Get(1037)   ;%; 
	Gui, Add, DropDownList, xp-165  yp     w150      vvLanguage_Nr_Int gEditLanguage cBlue  AltSubmit , %vLang_Select_All%

	; *** (1035)    define a new Hotkey - "None" = keep this hotkey: 
	Gui, Add, Text,     xp+215  yp+30  w500 h20                    , % Message_Get(1035) " " vCtrl_Alt_Y_Hotkey_Char   ;%;
	Gui, Add, Hotkey,   xp-215  yp     w200 h22  vvCtrl_Alt_Y_Hotkey gSubExtra cBlue , %vCtrl_Alt_Y_Hotkey%


	; *** Update-Dir
	Gui, Add, Edit,     xp     yp+220  w550 h20   vUpdate_UpdPath     gmUpdate_UpdPath cBlue, %Update_UpdPath%
	Gui, Font, W600 %FontStd%, %FontName%
	Gui, Add, Button,   xp+570 yp      w35 h25   gButtonUpdate   , ...  ;%;
	Gui, Font, W1 %FontSmall%, %FontName%
	;*** (1062)  Update-Dir (if empty: no dir used)
	Gui, Add, Text,     xp-570 yp+23  w500 h20                                , % Message_Get(1062) ;%;

	Gui, Font, W600 %FontStd%, %FontName%



	;***************************************************************
	; *** (1082)  E X T R A S - 2
	Gui, Tab,  % Message_Get( 1082 ) ;%;
	;***************************************************************
	Gui, Add, Text,     x50  y15 w0   SECTION
	Gui, Font, W100 %FontStd%, %FontName%

	; *** (1180)  WinSize2 deactivated (checked: no repositioning or resizing is done)
	If ( vWinSize2_Not_Active <> -1 )
	Gui, Add, Checkbox, xs     yp+25  w500 h20  vvWinSize2_Not_Active_Int gSubExtra Checked%vWinSize2_Not_Active_Int% , % Message_Get(1180)   ;%;

	; *** (1114)  Sort titles A .. Z
	Gui, Add, Checkbox, xs     yp+25  w500 h20  vTitles_Sort_Basis_Int gSubTitles_Sort_Basis  , % Message_Get(1114)   ;%;

	; *** (1115)  Sort titles Z .. A
	Gui, Add, Checkbox, xs+20     yp+20 w500 h20    vTitles_Sort_ZA_Int gSubTitles_Sort_ZA , % Message_Get(1115)   ;%;

	; *** (1071)  Different INIs depending on Screen Resolution, e.g.
	Gui, Add, Checkbox, xs     yp+25  w500 h20   vINI_with_ScreenSize gSubExtra Checked%INI_with_ScreenSize% , % Message_Get(1071) "  " vProgram_NNam "_" Screen_Width_Height ".INI"  ;%

	; *** (1116)  What to Log:  0=NoLog  1=Errors  2=Moves  3=Trace (default)  4=Details
	;Gui, Add, Edit,     xs     yp+30  w30  h20  vLogFile_Level gSubExtra cBlue   , %LogFile_Level%
	
	; *** (1130)  these messages and all before will be logged (TRACE if you need HELP)
	; *** (1131)  Nothing logged|Errors only|Moves and resizes|Trace (if you need HELP)|Details
	LogFile_Level_GUI := LogFile_Level + 1
	Gui, Add, DropDownList, xs  yp+30 w230      vLogFile_Level_GUI gSubExtra cBlue  Choose%LogFile_Level_GUI% AltSubmit , % Message_Get(1131)
	Gui, Add, Text,     xp+240  yp     w250 h40                                      , % Message_Get(1130) ;%;

	; *** <open last Tab> | WinTitle | Extras-1 | Extras-2 | Special | Group 
	TextAllTabs_DropDown := Message_Get(1129) "|" TextAllTabs
	Gui, Add, DropDownList, xs  yp+30 w230      vTabNumber_Open_Last_Tab gSubExtra cBlue  Choose%TabNumber_Open_Last_Tab% AltSubmit , %TextAllTabs_DropDown%
	; *** (1122)  Special Parameters: open last closed tab
	Gui, Add, Text,     xs+240  yp     w250 h40                  , % Message_Get(1128) ;%;



	;***************************************************************
	; *** (1083)  S P E C I A L
	Gui, Tab,  % Message_Get( 1083 ) ;%;
	;***************************************************************
	ColorBackground := ColorBlue
	ColorControl := 

	Gui, Add, Text,     x40    y35 w0

	; *** (1034)  Start WinSize2 with Login
	Gui, Add, Checkbox, xp+10  yp+15   w650 h20   vStartWinChecked gSubExtra Checked%StartWinChecked%, % Message_Get(1034)    ;%;
	GuiControl, Enable%StartWinEnabled%, StartWinChecked
	; Tooltip GuiControl Enable%StartWinEnabled% StartWinChecked

	; *** (1003)  Show WinSize2 icon in the taskbar
	Gui, Add, Checkbox, xp     yp+25 w215 h20   vvMenuTrayIcon_Show gSubExtra Checked%vMenuTrayIcon_Show%, % Message_Get(1003)    ;%; 

	; *** (1012)  TERMINATE NOW
	Gui, Font, W700 %FontStd%, %FontName%
	Gui, Add, Checkbox, xp+220  yp w430  h20    vPar_Exit_Now       gSubExtra  , % Message_Get(1012)    ;%;
	Gui, Add, Text,     xp-220  yp w0
	Gui, Font, W100 %FontStd%, %FontName%
	GuiControl, Disable%vMenuTrayIcon_Show%, Par_Exit_Now
	
	; *** (1032)  Start WinSize2 from every directory (CMD -> ..\System32)
	Gui, Add, Checkbox, xp     yp+25  w500 h20  vStart_WinSize2_Every_Dir gSubExtra Checked%Start_WinSize2_Every_Dir_Old% , % Message_Get(1032) ;%;

	; *** (1175)  Show time to wait, when "delayed move + send" in "WinTitle" is selected:   |*******____|
	Gui, Add, Checkbox, xp     yp+25  w700 h20  vDelay_Show_Tooltip_New gSubExtra Checked%Delay_Show_Tooltip_New% , % Message_Get(1175) ;%;

	; +------------------------------------------------------+
	; !                                                      !
	Gui, Add, GroupBox, xp-10  yp+25    w750 h68
	; *** (1041)  [msec] Show INI logo (0=do not show)
	Gui, Add, Text,     xp+95  yp+12  w500 h20                    , % Message_Get(1041)    ;%;
	Gui, Add, Edit,     xp-85  yp     w70  h20  vvIniScreen_Time_Show  gSubExtra cBlue, %vIniScreen_Time_Show%

	; *** (1038)   [msec] Show messages for this time
	Gui, Add, Text,     xp+85  yp+30  w650 h20                    , % Message_Get(1038)    ;%;
	Gui, Add, Edit,     xp-85  yp     w70  h20  vvTooltip_Time_Show  gSubExtra cBlue, %vTooltip_Time_Show%

	Gui, Add, GroupBox, xp-10  yp+18    w750 h68
	; !                                                      !
	; +------------------------------------------------------+
	
	; +------------------------------------------------------+
	; !                                                      !
	; *** (1039)    [msec] Execute command given by Hotkey after this time
	Gui, Add, Text,     xp+95  yp+12  w650 h20                    , % Message_Get(1039)    ;%; 
	Gui, Add, Edit,     xp-85  yp     w70  h20  vvCtrl_Alt_Y_Time   gSubExtra cBlue, %vCtrl_Alt_Y_Time%

	; *** (1036)    lower time = higher CPU load (lower time = higher CPU load)
	Gui, Add, Text,     xp+85  yp+30  w650 h20                    , % Message_Get(1036)    ;%; 
	Gui, Add, Edit,     xp-85  yp     w70  h20  vvTitleTimer        gSubExtra cBlue, %vTitleTimer%
	; !                                                      !
	; +------------------------------------------------------+
	
	; *** (1133)  Factor for size of characters (font size)
	Gui, Add, Text,     xp+85  yp+30  w650 h20                  , % Message_Get(1133)    ;%;
	Gui, Add, Edit,     xp-85  yp     w70  h20  vScreen_dpi_Font_Factor  gSubExtra cBlue , %Screen_dpi_Font_Factor%


	;***************************************************************
	; *** (1084)  G R O U P
	Gui, Tab,  % Message_Get( 1084 ) ;%;
	;***************************************************************
	ColorBackground := ColorBlue
	ColorControl := 
	; *=*=*=*=* Groups *=*=*=*=*
	Gui, Font, W550 %FontStd%, %FontName%

	; *** (1123)  Groups: activated by double-click
	; *** (1124)  Double-click activates Group
	; Gui, Add, Text,     xm+10  ym+10     h15    , % Message_Get(1124) ;%;
	Gui, Add, ListBox, xm     ym+20 w170 h310 cblue vGroup_Choose_Nr gGroupClick Choose%Group_Choose_Nr% AltSubmit, %Group_Choose_List%

	; filenames of one group
	Gui, Font, W700 %FontSmallS%, %FontName%
	Gui, Add, ListBox, xp+180 yp    w470 h310 cgreen vGroup_Content gGroupFileClick AltSubmit, 


	; *** (1125)  Resize windows of the Group
	Gui, Font, W600 %FontStd%, %FontName%
	Gui, Add, Button,  xp+480 yp  w110 h90  vButtonGroup gButtonGroup  SECTION  , % Message_Get(1125)  ;%;
	Gui, Font, W1 %FontStd%, %FontName%

	mGroup_Select( Group_Choose_Nr )
	GuiControl, , Group_Content , %Group_Content_Str%

	;*** (1020)  X-Coordinate / Y-Coordinate
	Gui, Font, W600 %FontStd%, %FontName%



	;***************************************************************
	; *** (1085)  D E S K T O P   I C O N  +  N E T W O R K
	Gui, Tab,  % Message_Get( 1085 ) ;%;
	;***************************************************************
	ColorBackground := ColorBlue
	ColorControl := 
	Gui, Font, W1 %FontStd%, %FontName%

	;*** (1134)  Desktop Icon Positions (currently not in use)
	; DesktopBoxTitle := Message_Get( 1134 )
	; Gui, Add, GroupBox,     xm550 ym30  w220 h420 vDesktopBoxTitle SECTION , %DesktopBoxTitle%  ;%;

	; *** (1135)  Auto check of icon positions after login
	;                                            DesktopIcon_CheckAfterLogin
	Gui, Add, Checkbox, x40    y35    w350  h20  vDesktopIcon_CheckAfterLogin gSubExtra Checked%DesktopIcon_CheckAfterLogin% SECTION  , % Message_Get(1135)    ;%; 
	; Gui, Add, Text,     xp+30 yp     w650 h20                    , % Message_Get(1135)    ;%; 
	; Gui, Add, Edit,     xp-80  yp     w70  h20  vDesktopIcon_CheckAfterLogin  gSubExtra cBlue , %DesktopIcon_CheckAfterLogin%

	; *** (1136)  Auto restore after login
	Gui, Add, Checkbox, xs     yp+20  w350 h20  vDesktopIcon_AutoRestore gSubExtra Checked%DesktopIcon_AutoRestore% , % Message_Get(1136) ;%;

	; *** (1155)  Check icon positions after changed screen resolution
	;                                           DesktopIcon_CheckResolution
	Gui, Add, Checkbox, xs     yp+20  w350 h20  vDesktopIcon_CheckResolution gSubExtra Checked%DesktopIcon_CheckResolution% , % Message_Get(1155) ;%;
	mDesktopIcon_Disable()

	; *** (1150)  1150=Store icon position in data file (unchecked=registry): 
	Gui, Add, Checkbox, xp     yp+17  w350 h40  vDesktopIcon_StoreInFile gSubExtra Checked%DesktopIcon_StoreInFile% , % Message_Get(1150) " " IniFile_File_DesktopIcon ;%;
	GuiControl, Disable1, DesktopIcon_StoreInFile
	

	Gui, Font, W700 %FontStd%, %FontName%
	; +--- DESKTOP ICONS ------------------------------------+
	; !                                                      !
	Gui, Add, GroupBox, xs     yp+50    w350 h200 SECTION                   , % Message_Get(1143) ;%;

	; +------------------------------------------------------+
	; !                                                      !
	Gui, Add, GroupBox, xs     ys+132   w350 h68
	; Text field for what was done

	Network_WithIconSave := ChkLogical(  Network_WithIconSave )
	Network_WithIconRestore := ChkLogical(  Network_WithIconRestore )

	; *** (1137)  Save positions
	; *** (1138)  Restore positions
	; *** (1139)  Check for changed icon positions
	Gui, Add, Button,   xs+10    ys+17    w230  h35 gButtonIconSave     , % Message_Get(1137) ;%;
	Gui, Add, Text,     xp       yp+36
	Gui, Add, Button,   xp       yp+25    w230  h35 gButtonIconRestore  , % Message_Get(1138) ;%;
	Gui, Add, Text,     xp       yp+36
	Gui, Add, Button,   xp       yp+38    w230  h35 gButtonIconChanged  , % Message_Get(1139) ;%;
	; !                                                      !
	; +--- DESKTOP ICONS ------------------------------------+

	;***************************************************************
	;  N E T W O R K   S E T T I N G S
	;***************************************************************
	mNetwork_MakeFile()
	; +--- NETWORK SETTINGS ---------------------------------+
	; !                                                      !
	Gui, Add, GroupBox, xs+380  ys-63   w350 h57    , % Message_Get(1160) ;%;
	Gui, Add, GroupBox, xs+380  ys-14   w350 h154   ; second box  (h214)
	; *** (1165)  Delete file
	Gui, Add, Button,   xp+10   ys-44  w100    vButtonNetworkDelete gButtonNetworkDelete  , % Message_Get(1166) ;%;
	; Combobox to select an existing file or input a new filename (for saving)
	Gui, Add, ComboBox, xp    yp+28  w270      vNetwork_ID_Select gSubExtra_NoMark cBlue               , %Network_ID_All%
	; !                                                      !
	; +--- NETWORK SETTINGS ---------------------------------+

	; +------------------------------------------------------+
	; !                                                      !
	;     Groupbox (see above)
	; *** (1160)  Network Settings
	; *** (1161)  Save network settings
	; *** (1162)  Save with "Save Icon"
	; *** (1163)  Restore network settings
	; *** (1164)  Restore with "Restore Icon"
	Gui, Add, Button,   xp    ys+17 w230 h35                           gButtonNetworkSave                         , % Message_Get(1161) ;%;
	Gui, Add, Checkbox, xp    yp+36 w330 h20 vNetwork_WithIconSave     gSubExtra Checked%Network_WithIconSave%    , % Message_Get(1162) ;%;
	Gui, Add, Button,   xp    yp+25 w230 h35 vNetwork_Restore          gButtonNetworkRestore                      , % Message_Get(1163) ;%;
	Gui, Add, Checkbox, xp    yp+36 w330 h20 vNetwork_WithIconRestore  gSubExtra Checked%Network_WithIconRestore% , % Message_Get(1164) ;%;
	mNetwork_MakeFile()
	; Gui, Add, Button,   xp    yp+35 w230 h35                         gButtonNetworkChanged                 , % Message_Get(1165) ;%;
	; !                                                      !
	; +------------------------------------------------------+

	Gui, Add, Text,     xp       yp+40    w330 h40 vButtonIconDoneTextRed   cMaroon 
	Gui, Add, Text,     xp       yp       w330 h20 vButtonIconDoneTextGreen cGreen

;***************************************************************
	;  E N D
	;***************************************************************

	; WinSet, Style, -0xC00000, A  ; Remove the active window's title bar (WS_CAPTION).
	; WinSet, Style, +0x400000, A  ; Creates a window that has a border of a style typically used with dialog boxes.

	;---------------------------------------------------------------

	Gui, Show, X%GuiWindowX%  Y%GuiWindowY% H%GuiWindowHeight% W%GuiWindowWidth%, %GuiCaption% ; Special Parameters
	; msgbox Gui Show X%GuiWindowX%  Y%GuiWindowY% H%GuiWindowHeight% W%GuiWindowWidth% Message_Get(1052) 

	GoSub ButtonPlus_01

	; --- wait here until "OK", "Abort", ...
	Loop
	{
		If ( vGUI_TERMINATE_NOW >= 10 )
			Break
		; tooltip WaitGuiEnd: vGUI_TERMINATE_NOW %vGUI_TERMINATE_NOW%
		Sleep 200
	}
	Return

;==================================================================
; gTabNumber_ActTab:	  the tab is changed
TabNumber_ActTab:	

/*
	If ( TabNumber_ActTab = 4 )
	{
		Gui , Color, %ColorBackground% , %ColorControl%
	}
	Else
	{
		Gui , Color, Default, Default
	}

	Tooltip Color %TabNumber_ActTab%  /%ColorBackground%/
	; TabNumber_ActTab_Old := TabNumber_ActTab
*/

	Return
	
;==================================================================
; --- click into left window: select a complete group
; gGroupClick:
GroupClick:
	Gui, Submit, NoHide

	ColorBackground := ColorBlue
	ColorControl := 

	; *** (1125)  Resize all windows of the Group
	GuiControl, , ButtonGroup   , % Message_Get(1125) cBlue  ;%;
	mGroup_Select( Group_Choose_Nr )
	GuiControl, , Group_Content , %Group_Content_Str%

	; msgbox Group_Choose_Nr: %A_GuiEvent% / %A_EventInfo% "%Group_Choose_Nr%"  `n%Group_Content_Str%

	GoSub TextOK_Set_NoMark
	Return

;===============================
; --- click into right winodw: select a file of a group
; gGroupFileClick:
GroupFileClick:
	Gui, Submit, NoHide

	ColorBackground := ColorGreen
	ColorControl := 

	; *** (1126)  Resize this one window only
	GuiControl, , ButtonGroup   , % Message_Get(1126)  ;%;
	mGroup_Select( Group_Choose_Nr )
	; msgbox Group_Choose_Nr: %A_GuiEvent% / %A_EventInfo% "%Group_Choose_Nr%"  `n%Group_Content_Str%

	GoSub TextOK_Set_NoMark
	Return

;===============================
; gButtonGroup:
ButtonGroup:
	Gui, Submit, NoHide

	StringSplit, Group_Content_ , Group_Sort_Index_%Group_Choose_Nr% , %CUT1%
	If ( Group_Cnt = 0 )
	{
		; *** (1127)  No groups defined:|insert "Group:Comment"|to comment field
		MsgBox % Group_Choose_Nr "/" Group_Content "`n" Group_Choose_List
		Return
	}
	If ( Group_Content <> "" )
	{
		AW_ListIndex := Group_Content_%Group_Content%
		Group_Choose_Name := Group_Choose_Name_%Group_Content%

		mWinSize2_StringSplit( AW_ListIndex )
		mWinSize2_StringSplit_to_AW()
		; msgbox 1_Window_Selected %Group_Choose_Nr%: %Group_Choose_Name%: %AW_ListIndex%
		mWinSize2_WinMove( 1 )
	}
	Else
	{
		; msgbox % "leer02 " Group_Sort_Index_%Group_Choose_Nr%
		mGroup_Resize( Group_Choose_Nr )
	}
	; MsgBox % "ButtonGroupApply # " Group_Choose_Nr "/ :" Group_Content ": / "Group_Sort_Name_%Group_Choose_Nr% ":: " Group_Sort_Index_%Group_Choose_Nr%

	Return
	
;==================================================================
ButtonAppend:
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide
	GoSub Disable_for_Time

	split_FullScr_Act := Message_Get( AppendReturn_Start + AppendReturn_Intg - 1 )
	split_FullScr_Sum .= split_FullScr_Act
	
	GoSub SubFullScreen_Char_Change
	ButtonChange_Enable( 1 )
	AWNr_Element_Make()
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar

	; tooltip % AppendReturn_Intg " ButtonAppend: " split_FullScr_Act " / " split_FullScr_Sum 
	;%
	Return
	
SubAppendReturn:
	Gui, Submit, NoHide
	Return
	
	; ----------------------------------------
SubDefault:
	Gui, Submit, NoHide
SubDefault_01:
	GoSub TextOK_Set
	GoSub mPar_Exit_Now_Enable
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar
	Return
	
; ----------------------------------------
;  gSubTitles_Sort_Basis:
SubTitles_Sort_Basis:
	Gui, Submit, NoHide
	Titles_Sort_Basis := Titles_Sort_Basis_Int
	If ( ! Titles_Sort_Basis )
	{
		Titles_Sort_ZA := 0
	}
	mGroup_Sort()
	; mGroup_Select( Group_Choose_Nr )
	Sort_Titles()
	Title_Number_Old := 0
	mTitle_Number_Set( 1 )

	Gosub DropDownTitle_01
	; Tooltip SubTitles_Sort_Basis %Titles_Sort_Basis% %Titles_Sort_ZA%
	Goto SubExtra_01

; ----------------------------------------
;  gSubTitles_Sort_ZA:
SubTitles_Sort_ZA:
	Gui, Submit, NoHide
	Titles_Sort_ZA := Titles_Sort_ZA_Int
	If ( Titles_Sort_ZA )
	{
		Titles_Sort_Basis := 1
	}
	mGroup_Sort()
	; mGroup_Select( Group_Choose_Nr )
	Sort_Titles()
	Title_Number_Old := 0
	mTitle_Number_Set( 1 )

	Gosub DropDownTitle_01
	; Tooltip SubTitles_Sort_ZA %Titles_Sort_Basis% %Titles_Sort_ZA%
	Goto SubExtra_01
	
	; ----------------------------------------

; gSubExtra_NoMark:
SubExtra_NoMark:
	Gui, Submit, NoHide
	LogFile_Level := LogFile_Level_GUI - 1

	mNetwork_MakeFile( 0 )
	DesktopIcon_AutoRestore := ChkLogical( DesktopIcon_AutoRestore )
	GuiControl, Disable%DesktopIcon_AutoRestore%, DesktopIcon_CheckAfterLogin
	GoSub Screen_Factor
	AWNr_Deleted_Ignore := 1
	GoSub TextOK_Set_NoMark
	GoSub mPar_Exit_Now_Enable
	GoSub Para_Timer_FillVar_Start
	Return
	

	; ----------------------------------------

; gSubExtra:
SubExtra:
	Gui, Submit, NoHide
	LogFile_Level := LogFile_Level_GUI - 1

SubExtra_01:

	mDesktopIcon_Disable()
	GoSub Screen_Factor
	AWNr_Deleted_Ignore := 1
	GoSub TextOK_Set
	GoSub mPar_Exit_Now_Enable
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar
	Return
	
	; ----------------------------------------
mPar_Exit_Now_Enable:
	If ( vMenuTrayIcon_Show )
		Par_Exit_Now := 0
	GuiControl,                            , Par_Exit_Now , %Par_Exit_Now%
	GuiControl, Disable%vMenuTrayIcon_Show%, Par_Exit_Now
	Return

	; ----------------------------------------
SubFullScreen_Char_Change:
	If ( Disable_TickCount > A_TickCount )
		Return
	FullScreen_Char_changed += 1
	Gui, Submit, NoHide
	; GoSub Disable_for_Time

	ButtonName = SubFullScreen_Char_Change
	;....................................................
	split_FullScr_Sum := split_FullScr
	;....................................................

	; --- if not set till now: FullScreen... has to be changed
	; split_Title_NrAW := AWNr_XRef_%split_Title_NrInt%
	; mTitle_Number_Set( split_Title_NrInt )
	split_Title_Edit := split_Title_Edit_Old_%split_Title_NrAW%
	If ( split_Title_Edit = "***" OR split_Title_Edit = "" )
		split_Title_Edit_Old_%split_Title_NrAW% := split_Title
	; msgbox % FullScreen_Char_changed split " SubFullScreen_Char_Change: " split_Title_Edit "  " split_FullScr_Sum ;%

	Goto Change_Made_01


	; ----------------------------------------
sub_Titles_Sort_wComm:
	Gui, Submit, NoHide
	; Tooltip sub_Titles_Sort_wComm %Titles_Sort_wComm% %Titles_Sort_wComm_Int%
	If ( Titles_Sort_wComm = Titles_Sort_wComm_Int )
		Return

	Titles_Sort_wComm := Titles_Sort_wComm_Int
	Sort_New := 1
	GoSub TextOK_Set
	Return
	Goto Change_Made_01

	Sort_Titles()
	Title_Number_Old := 0
	mTitle_Number_Set( 1 )

	Gosub DropDownTitle_01
	Goto SubExtra_01
	
sub_split_AhkClass_Used:
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide
	; Tooltip split_AhkClass_Used: "%split_AhkClass_Used%"  "%split_AhkClass_Used_GUI%"
	; If ( split_AhkClass_Used = split_AhkClass_Used_GUI )
	;	Return
	split_AhkClass_Used := split_AhkClass_Used_GUI
	If ( split_AhkClass_Used = 0 )
		split_AhkClass_UsedInt := 0
	Else
		split_AhkClass_UsedInt := 999
	; --- e.g. "100999ClassName"
	split_AhkClass_Set( split_AhkClass_UsedInt, split_AhkClass_Name )
	Goto Change_Made_01
	

sub_split_Comment_Use:
	Gui, Submit, NoHide
	; tooltip 01 sub_split_Comment_Use %split_Comment_Use%  %split_Comment_Use_Int%
	If ( split_Comment_Use = split_Comment_Use_Int )
		Return

	Sort_New := 1
	split_Comment_Use := split_Comment_Use_Int 
	; tooltip 02 sub_split_Comment_Use %split_Comment_Use%  -%split_Comment_Text%-
	Goto Change_Made_01
	
sub_split_Comment_Text:
	Gui, Submit, NoHide
	If ( split_Comment_Text = split_Comment_Text_Int )
		Return

	Sort_New := 1
	split_Comment_Text := split_Comment_Text_Int 
	split_Comment_Text_Changed := 1
	Goto Change_Made_01
	
sub_split_Delay:
	Gui, Submit, NoHide
	If ( split_Delay = split_Delay_Int )
		Return
	split_Delay := split_Delay_Int 
	Goto Change_Made_01
	
sub_split_X_Coord:
	Gui, Submit, NoHide
	If ( split_X_Coord = split_X_Coord_Int )
		Return
	split_X_Coord := split_X_Coord_Int
	Goto Change_Made_01

sub_split_Y_Coord:
	Gui, Submit, NoHide
	If ( split_Y_Coord = split_Y_Coord_Int )
		Return
	split_Y_Coord := split_Y_Coord_Int
	Goto Change_Made_01

sub_split_XY_Always:
	Gui, Submit, NoHide
	If ( split_XY_Always = split_XY_Always_Int )
		Return
	split_XY_Always := split_XY_Always_Int
	Goto Change_Made_01

sub_split_Width:
	Gui, Submit, NoHide
	If ( split_Width = split_Width_Int )
		Return
	split_Width := split_Width_Int
	Goto Change_Made_01

sub_split_Height:
	Gui, Submit, NoHide
	If ( split_Height = split_Height_Int )
		Return
	split_Height := split_Height_Int
	Goto Change_Made_01

sub_split_WH_Always:
	Gui, Submit, NoHide
	If ( split_WH_Always = split_WH_Always_Int )
		Return
	split_WH_Always := split_WH_Always_Int
	Goto Change_Made_01

sub_split_AlwaysOnTop:
	Gui, Submit, NoHide
	If ( split_AlwaysOnTop = split_AlwaysOnTop_Int )
		Return
	split_AlwaysOnTop := split_AlwaysOnTop_Int
	Goto Change_Made_01

sub_MinNormMax:
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide
	If ( split_MinNormMax <> split_MinNormMax_Int )
	{
		split_MinNormMax := split_MinNormMax_Int
		ButtonChange_Enable( 1 )
		GoSub mDropDownMinNormMax
	}
	Return
	
mUpdate_UpdPath:
	AWNr_Deleted_Ignore := 1
	GoSub TextOK_Set
	GoSub mPar_Exit_Now_Enable
	Goto Change_Made_01

Change_Made:
	Goto Change_Made_01

;--------------
Change_Made_01:
	TickCount_Diff := Disable_TickCount - A_TickCount
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide

	; Tooltip 02 Changed: "%A_GuiControl%"    "%Titles_Sort_wComm%" "%split_Comment_Use%" "%split_Comment_Text%"  "%TickCount_Diff%"
	mShowButton( A_GuiControl )
	ButtonChange_Enable( 1 )

	Return

	; ----------------------------------------------------------------
StartWin:
	Gui, Submit, NoHide
	; msgbox StartWin %StartWinChecked%
	Return

	; ----------------------------------------------------------------
DropDownTitle:
	If ( Disable_TickCount > A_TickCount )
		Return

	mShowButton( "DropDownTitle" )
	Gui, Submit, NoHide
	; split_Title_NrInt := DropDownTitle_Nr
	; msgbox DropDownTitle: split_Title_NrInt %split_Title_NrAW%
	
DropDownTitle_01:
	mTitle_Number_Add( 0 )
	GoSub WinSize2_Parameter_Split
	GoSub mDropDownTitle_Make
	/*
	Title_NrInt := split_Title_NrInt 
	If ( Title_Number_Old <> Title_NrInt )
	{
		Title_Number_Old := Title_NrInt
		mTitle_Number_Get( Title_NrInt )


		; ButtonChange_Enable( 1 )
		; GoSub mDropDownTitle_Make
	}
	*/
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar
	mTitle_Number_XRefStr_Disp()

	Return

; ----------------------------------------------------------------
; gEditTitle:
EditTitle:
	If ( Disable_TickCount > A_TickCount )
		Return

	split_Title_Old := split_Title
	split_Title_NrInt_Old := split_Title_NrInt

	If ( split_MinNormMax  = 5 )  ; full screen
	{
		split_Title_Edit_Old_%split_Title_NrInt% := split_Title_Old
	}

	mShowButton( "DropDownTitle" )
	Gui, Submit, NoHide
	; If ( split_Title_Old <> split_Title )
	If ( split_Title_NrInt_Old = split_Title_NrInt )
	{
		ButtonChange_Enable( 1 )
	}
	Return

; ----------------------------------------------------------------
; gEditLanguage
EditLanguage:
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide

	GoSub TextOK_Set
	mShowButton( "EditLanguage" )
	ButtonChange_Enable( 1 )

	vLanguage_Nr_Name := vLang_Token_%vLanguage_Nr_Int%

	; msgbox vLanguage_Name  "%vLanguage_Nr%"   "%vLanguage_Nr_Int%"   "%vLanguage_Nr_Name%"
	Return

	; ----------------------------------------------------------------
	; SUB gScreen_Factor
Screen_Factor:
	If ( Screen_dpi_Font_Factor < 0.8 ) 
		Screen_dpi_Font_Factor  = 1.0
	If ( Screen_dpi_Font_Factor > 1.8 ) 
		Screen_dpi_Font_Factor  = 1.0

	; calc DPI-factor: factor for 96dpi = 1
	Screen_dpi_Factor := 96.0 / Screen_dpi * Screen_dpi_Font_Factor
	Screen_dpi_Factor_8 := Screen_dpi_Factor * 8
	Screen_dpi_Factor_7 := Screen_dpi_Factor * 7
	Screen_dpi_Factor_19 := Screen_dpi_Factor * 19

	; --- vMessage_Help: show the message numbers: "(xxxx)"
	If ( vMessage_Help = 0 )
		FontStd = S%Screen_dpi_Factor_8% cBlack
	Else
		FontStd = S%vMessage_Font%       cBlack W500
	
	FontSmall   = S%Screen_dpi_Factor_8% cBlack
	FontSmallS  = S%Screen_dpi_Factor_8% cBlack W1
	FontSmallVS = S%Screen_dpi_Factor_7% cBlack W1
	FontMarker  = S%Screen_dpi_Factor_19% cBlack
	Return

	; ----------------------------------------------------------------
ButtonExitNow:
	mShowButton( "ButtonExitNow" )
	GoSub TextOK_Set
	Par_Exit_Now = 1
	Return
	
	; ----------------------------------------------------------------
ButtonEdit:
	If ( ButtonEdit_Shown )
		ButtonEdit_Shown := 0
	Else
		ButtonEdit_Shown := 1
	GuiControl , Show%ButtonEdit_Shown%  , TextContain        ; explaining text
	GuiControl , Hide%ButtonEdit_Shown%  , ButtonEdit         ; "Edit" button

	GuiControl , Show%ButtonEdit_Shown%  , split_Title        ; Title text to be edited
	GuiControl , Hide%ButtonEdit_Shown%  , split_Title_NrInt  ; DropDown Titels
	
	Return
	
	; ----------------------------------------------------------------
ButtonPlus:
	If ( Disable_TickCount > A_TickCount  )
		Return
	GoSub Text2Change_IsSet
	If ( Text2Change <> "" )
		Return
	mShowButton( "ButtonPlus" )
	; msgbox Text2Change 01 = %Text2Change%

	FullScreen_Char_changed := 0
	Gui, Submit, NoHide
	mTitle_Number_Add( +1 )

ButtonPlus_01:
	GoSub WinSize2_Parameter_Split
	GoSub mDropDownTitle_Make
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar
	mTitle_Number_XRefStr_Disp()
	
	ButtonChange_Enable( 0 )
	; msgbox vsplit_AhkClass_Used/_Name: "%split_AhkClass_Used%" "%split_AhkClass_Name%" 

	Return

	; ----------------------------------------------------------------
ButtonMinus:
	If ( Disable_TickCount > A_TickCount )
		Return
	GoSub Text2Change_IsSet
	If ( Text2Change <> "" )
		Return
	mShowButton( "ButtonMinus" )
	FullScreen_Char_changed := 0
	Gui, Submit, NoHide
	mTitle_Number_Add( -1 )
	GoSub WinSize2_Parameter_Split
	GoSub mDropDownTitle_Make
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar
	mTitle_Number_XRefStr_Disp()
	
	ButtonChange_Enable( 0 )

	Return

; ----------------------------------------------------------------
; gButtonDelete:
ButtonDelete:
	If ( Disable_TickCount > A_TickCount )
		Return
	WinSet AlwaysOnTop, Off, %split_Title%
	Gui, Submit, NoHide
	GoSub TextOK_Set
	mShowButton( "ButtonDelete" )

	AWNr_%split_Title_NrAW% :=
	AWNr_XRef_%split_Title_NrInt% := 9999   ; as there are no "Array out of Bounds" errors

	mTitle_Number_XRefStr_Disp()

	GoSub mDropDownTitle_Make
	GoSub WinSize2_Parameter_Split
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar
	; msgbox % "ButtonDelete: " split_Title_NrInt "/" split_Title_NrAW "/" split_Title   ;%;

	Return

; ----------------------------------------------------------------
; gButtonChange:
ButtonChange:
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide
	If ( split_MinNormMax = 5 )
		If ( split_Title_Edit_Old_%split_Title_NrAW% = "***" )
			split_Title_Edit_Old_%split_Title_NrAW% :=

	mShowButton( "ButtonChange" )
	split_AhkClass_Set( split_AhkClass_Used , split_AhkClass_Name )
	; msgbox ButtonChange 01: split_Title "%split_Title%"  --%split_AhkClass_UsedStr%-- `n %split_AhkClass% `n "%AWNr_Element%"
	AWNr_Element_Make()
	mLogFile_Write( 1, "Button ""Change"": " AWNr_Element )

	; msgbox ButtonChange 02: split_Title "%split_Title%"  --%split_AhkClass_UsedStr%-- `n %split_AhkClass% `n "%AWNr_Element%"
	; split_Title_NrAW := AWNr_XRef_%split_Title_NrInt%
	AWNr_%split_Title_NrAW% = %AWNr_Element%

	If ( Sort_New )
	{
		split_Title_NrAW_Demand := split_Title_NrAW
		Sort_Titles()
	}
	Sort_New := 0
	GoSub FullScreen_Char_IsSet

	; msgbox % "ButtonChange: " split_Title_NrAW "  " AWNr_%split_Title_NrAW% "  " split_FullScr_Sum
	;kkkk If ( split_Title_Old <> split_Title )
		GoSub mDropDownTitle_Make
	GoSub WinSize2_Parameter_Split
	GoSub Para_Timer_FillVar_Start   ; Para_FillVar

	/*
	;* AAAA
	If ( Tooltip_Show_Store )
	{
	TTL := 004
	TTLMsg := 
	TTLMsg := ATime() ":  (" TTL ") ButtonChange:  " split_Title_NrAW " / " AWNr_Element
	Tooltip_%TTL% := TTLMsg
	If ( Tooltip_Show_Tip = 1 )
	{
	CoordMode, ToolTip, Screen
	Tooltip %TTLMsg%  ,TTX , TTL*TTM, TTL+TTP ;%
	CoordMode, ToolTip, Relative
	}  }
	;* EEEE
	*/

	GoSub TextOK_Set
	
	;msgbox Text2Change 04 = %Text2Change%
	GuiControl,        , TextChange ,
	GoSub TextOK_Set

	ButtonChange_Enable( 0 )
	mAWNr_Display()

	Return

	; ----------------------------------------------------------------
FullScreen_Char_IsSet:
	If ( FullScreen_Char_changed )
	{
		mFullScreen_Replace( split_Title_Old, split_Title, split_FullScr_Sum )
		; msgbox FullScreen_Char_IsSet: %split_Title_Old% / %split_Title% / %split_FullScr_Sum%
	}
	Return

	; ----------------------------------------------------------------
; --- enable OK but don't ask "All changes lost"
TextOK_Set_NoMark:
	GuiControl, Enable   , ButtonOK
	GuiControl, +Default , ButtonOK
	Return

; --- enable OK and ask if "All changes lost"
TextOK_Set:
	
	If ( AWNr_Deleted = 0 OR AWNr_Deleted_Ignore )
	{
		AWNr_Deleted_Ignore := 0
		
		If ( TextOK = "" )
		{
			TextOK := Message_Get(1098)  ; >>>
			TextOK_Mark := 1
		}
		
		GuiControl,          , TextOK     , %TextOK%
		GuiControl, Enable   , ButtonOK
		GuiControl, +Default , ButtonOK
	}
	Return

	; ----------------------------------------------------------------
Text2Change_IsSet:
	GuiControlGet , Text2Change,, TextChange
	;msgbox Text2Change 05 %Text2Change%
	If ( Text2Change <> "" )
	{
		Gui +OwnDialogs
		; "!" Yes/NO
		Text00 := Message_Get(1099)   ; WinSize2 Parameters changed
		Text01 := Message_Get(1100)   ; All changes lost ?
		MsgBox 52, %Text00%, %Text01%
		; Text2Change: "%Text2Change%"
		IfMsgBox, Yes
			Text2Change :=
	}
	Return

	; ----------------------------------------------------------------
TextOK_IsSet:
	GuiControlGet , TextOK,, TextOK
	;msgbox TextOK %TextOK%
	If ( TextOK <> "" )
	{
		Gui +OwnDialogs
		; "!" Yes/NO
		Text00 := Message_Get(1099)   ; WinSize2 Parameters changed
		Text01 := Message_Get(1100)   ; All changes lost ?
		MsgBox 52, %Text00%, %Text01%
		; TextOK: "%TextOK%"
		IfMsgBox, Yes
			TextOK =
	}
	Return

	; ----------------------------------------------------------------
Disable_for_Time:
	Disable_TickCount := A_TickCount + Disable_TickCount_Add
	Disable_TickCount_Start := A_TickCount
	Return
	
	; ----------------------------------------------------------------
ButtonUpdate:
	Gui, Submit, NoHide
	mShowButton( "ButtonUpdate" )
	; (1063) Directory for the update of Winsize2
	FileSelectFolder, Update_UpdPath, *%Update_UpdPath%, 1, % Message_Get(1063)"`n`n"Update_UpdPath ;%;
	GuiControl,, Update_UpdPath, %Update_UpdPath%
	Return

	; ----------------------------------------------------------------
WinSize2_Parameter_Split:

	ButtonEdit_Shown := 1
	GoSub ButtonEdit
	mTitle_Number_Set( split_Title_NrInt )

	Number := AWNr_XRef_%split_Title_NrInt%
	AWNr_Element := AWNr_%Number%
	; tooltip WinSize2_Parameter_Split "%split_Title_NrInt%" "%AWNr_Element%"

	BoxTitleText := << deleted >>
	
/*
	If ( AWNr_Element = "" )
	{
		mWinSize2_StringSplit( 0 )
	}
	Else
	{
*/

	;-----------------------------------------------------------------
	mWinSize2_StringSplit( Number )
	;-----------------------------------------------------------------

	; msgbox WinSize2_Parameter_Split %AWNr_Element%

	If ( AWNr_Deleted = 0 )
	{

		;***(1111) **
		;***(1112) Contained** in ...
		If ( split_MatchMode = 2 )
			BoxTitleText := Message_Get(1111)  Message_Get(1112) " "

		;***(1113) Complete ...
		If ( split_MatchMode = 3 )
			BoxTitleText := Message_Get(1113) " "
			
		split_Title_Old := split_Title
		split_Title_NrInt_Old := split_Title_NrInt
		; (Complete / **Contained** in)   (1110) Window Title
		BoxTitleText := BoxTitleText Message_Get(1110)
		If ( Titles_Sort_ZA )
			BoxTitleText .= "  Z..A"
		Else If ( Titles_Sort_Basis )
			BoxTitleText .= "  A..Z"
		
		split_MinNormMax_Int := split_MinNormMax
		/*
		If ( ! FullScreen_Char_changed )
		{
			split_FullScr_Sum := mFullScreen_Find( split_Title )
			If ( split_FullScr_Sum = "" )
				split_FullScr_Sum = {Return}
			; tooltip split_FullScr_Sum 01 = %split_FullScr_Sum%
		}
		*/
	}

	/*
	;* AAAA
	If ( Tooltip_Show_Store )
	{
	TTL := 004
	TTLMsg := ATime() ":  (" TTL ") " mWinSize2_StringSplit_Cnt " WinSize2_Parameter_Split:  " split_Done " " split_Title_NrInt "/" split_Title_NrInt "/" Number "/  " AWNr_%Number% "   / " split_Title

	TTLMsg .= "`n" split_Title_NrInt ":" split_Title "|" split_X_Coord "|" split_Y_Coord "|" split_Width "|" split_Height
	TTLMsg .= "|  " split_MatchMode "|" split_AlwaysOnTop "|" split_Delay 
	TTLMsg .= "|  " split_XY_Always "|" split_WH_Always "|" split_MinNormMax "|" split_AhkClass_Name "|" split_FullScr_Sum "|" split_Comment_Use "|" split_Comment_Text "|" AA1

			Tooltip_%TTL% := TTLMsg
	If ( Tooltip_Show_Tip = 1 )
	{
	CoordMode, ToolTip, Screen
	Tooltip %TTLMsg%  ,TTX , TTL*TTM, TTL+TTP ;%
	CoordMode, ToolTip, Relative
	}  }
	;* EEEE
	*/

	mAWNr_Display()

	Return
	
	; ----------------------------------------------------------------
Para_Timer_FillVar_Start:
	
	;------------------------------------
	;  do once - stop after time elapsed
	SetTimer, Para_Timer_FillVar, -100
	;------------------------------------

	mTitle_Number_Set( split_Title_NrInt )
	
/*
	; if more than 1 call: determine the time between the calls
	aaPara_Timer_TimeDiff0 := A_TickCount - aaPara_Timer_TimeStart
	If ( aaPara_Timer_TimeDiff0 > 1000 )
	{
		If ( aaPara_Timer_TimeCnt > 0 )
		{
			aaPara_Timer_TimeDiff := aaPara_Timer_TimeSum / aaPara_Timer_TimeCnt
			Tooltip aaPara_Timer_TimeDiff:  %aaPara_Timer_TimeDiff%  %aaPara_Timer_TimeSum%  %aaPara_Timer_TimeCnt%
			aaPara_Timer_TimeSum := 0
			aaPara_Timer_TimeCnt := 0
		}
	}
	Else
	{
		aaPara_Timer_TimeSum += aaPara_Timer_TimeDiff0
		aaPara_Timer_TimeCnt += 1
	}
	aaPara_Timer_TimeStart := A_TickCount
*/
	
	Return
	
	; ----------------------------------------------------------------
Para_Timer_FillVar:

	GoSub Disable_for_Time

	; GoSub mDropDownTitle_Make
	; Tooltip Para_Timer_FillVar: %Split_Title_NrInt%  %split_FullScr_Sum%
	; GoSub mDropDownMinNormMax

	;-----------------------------------------------------
	; GoSub WinSize2_Parameter_Split
	;-----------------------------------------------------

	/*
	; If ( split_Title_Old <> split_Title )
	If ( split_Title_NrInt_Old = split_Title_NrInt )
	{
		; GoSub mDropDownTitle_Make
	}
	*/
	split_Comment_Use := ChkLogical( split_Comment_Use )
	split_XY_Always := ChkLogical( split_XY_Always )
	split_WH_Always := ChkLogical( split_WH_Always )
	split_AlwaysOnTop := ChkLogical( split_AlwaysOnTop )
	split_AhkClass_Used := ChkLogical( split_AhkClass_Used )
	
	GuiControl,, BoxTitle              , %BoxTitleText%
	GuiControl,, split_Title           , %split_Title%
	GuiControl,, split_Comment_Use_Int     , %split_Comment_Use%
	GuiControl,, split_Comment_Text_Int    , %split_Comment_Text%
	GuiControl,, split_X_Coord_Int         , %split_X_Coord%
	GuiControl,, split_Y_Coord_Int         , %split_Y_Coord%
	GuiControl,, split_XY_Always_Int       , %split_XY_Always%
	GuiControl,, split_Width_Int           , %split_Width%
	GuiControl,, split_Height_Int          , %split_Height%
	GuiControl,, split_WH_Always_Int       , %split_WH_Always%
	GuiControl,, split_AlwaysOnTop_Int     , %split_AlwaysOnTop%
	GuiControl,, split_MinNormMax          , %split_MinNormMax%
	GuiControl,, split_Delay_Int           , %split_Delay%
	GuiControl,, split_AhkClass_Name_GUI   , %split_AhkClass_Name%
	GuiControl,, split_AhkClass_Used_GUI   , %split_AhkClass_Used%
	GuiControl,, split_Title_NrInt         , %tsplit_Title%
	GuiControl,, split_FullScr             , %split_FullScr_Sum%

	GuiControl,, Title_Number_Sort         , %Title_Number_Sort%

	GuiControl,, Titles_Sort_Basis_Int     , %Titles_Sort_Basis%
	GuiControl,, Titles_Sort_ZA_Int        , %Titles_Sort_ZA%
	; GuiControl,, Titles_Sort_wComm_Int , %Titles_Sort_wComm%
	; Tooltip Para_FillVar %split_Title_NrInt% _Basis _ZA %Titles_Sort_Basis% %Titles_Sort_ZA% Delay %split_Delay% %split_Title%

	; GuiControl,, TextChange            ,
	; ButtonChange_Enable( 0 )
	split_Title_Old := split_Title
	split_Title_NrInt_Old := split_Title_NrInt

	/*
	;* AAAA
	If ( Tooltip_Show_Store )
	{
			AWNr_Element := split_Title_NrInt ":" split_Title "|" split_X_Coord "|" split_Y_Coord "|" split_Width "|" split_Height
			AWNr_Element .= "|  " split_MatchMode "|" split_AlwaysOnTop "|" split_Delay 
			AWNr_Element .= "|  " split_XY_Always "|" split_WH_Always "|" split_MinNormMax "|" split_AhkClass_Name "|" split_FullScr_Sum "|" split_Comment_Use "|" split_Comment_Text "|" AA1

	TTL := 005
	TTLMsg := 
	TTLMsg := ATime() ":  (" TTL ") " mWinSize2_StringSplit_Cnt " Para_FillVar:  " AWNr_Element
	Tooltip_%TTL% := TTLMsg
	If ( Tooltip_Show_Tip = 1 )
	{
	CoordMode, ToolTip, Screen
	Tooltip %TTLMsg%  ,TTX , TTL*TTM, TTL+TTP ;%
	CoordMode, ToolTip, Relative
	}  }
	;* EEEE
	*/

	GoSub mDropDownMinNormMax


	; msgbox Para_FillVar  %split_Title% / %split_X_Coord% / %split_Y_Coord% / %split_Width% / %split_Height% / %split_MinNormMax%
	Return

	; ----------------------------------------------------------------
mDropDownMinNormMax:
; {
	; Global
	
	; --- show the Fullscreen fields
	If ( split_MinNormMax = 5 )
		ShowFullScreen = Show
	Else
		ShowFullScreen = Hide

	; split_FullScr_Sum := mFullScreen_Find( split_Title )
	; GuiControl,, split_FullScr , %split_FullScr_Sum%

	GuiControl, %ShowFullScreen%, FullScreen_Text
	GuiControl, %ShowFullScreen%, split_FullScr
	GuiControl, %ShowFullScreen%, AppendReturn_Intg
	GuiControl, %ShowFullScreen%, ButtonAppend
	; msgbox GuiControl split_FullScreen_xx: %split_MinNormMax%  %ShowFullScreen%  "%split_FullScr_Sum%"

	; split_MinNormMax   1:Normal  2:Hidden  3:Minimized  4:Maximized  5:FullScreen
	If ( split_MinNormMax  = 1 )
		tsplit_MinNormMax := "|" Message_Get(1073) "||" Message_Get(1074) "|" Message_Get(1075) "|" Message_Get(1076) "|" Message_Get(1077)
	Else If ( split_MinNormMax  = 2 )
		tsplit_MinNormMax := "|" Message_Get(1073) "|" Message_Get(1074) "||" Message_Get(1075) "|" Message_Get(1076) "|" Message_Get(1077)
	Else If ( split_MinNormMax  = 3 )
		tsplit_MinNormMax := "|" Message_Get(1073) "|" Message_Get(1074) "|" Message_Get(1075) "||" Message_Get(1076) "|" Message_Get(1077)
	Else If ( split_MinNormMax  = 4 )
		tsplit_MinNormMax := "|" Message_Get(1073) "|" Message_Get(1074) "|" Message_Get(1075) "|" Message_Get(1076) "||" Message_Get(1077)
	Else If ( split_MinNormMax  = 5 )
		tsplit_MinNormMax := "|" Message_Get(1073) "|" Message_Get(1074) "|" Message_Get(1075) "|" Message_Get(1076) "|" Message_Get(1077) "||" 
	
	; ----------------------------------------------------------------
	; show the coordinates fileds
	If ( split_MinNormMax  = 1
		OR split_MinNormMax  = 5 )
		Coord_Enable = 1
	Else
		Coord_Enable = 0

	; En- / Disable all coordinate-fields
	GuiControl, Enable%Coord_Enable%, split_X_Coord_Int
	GuiControl, Enable%Coord_Enable%, split_Y_Coord_Int
	GuiControl, Enable%Coord_Enable%, split_XY_Always_Int
	GuiControl, Enable%Coord_Enable%, split_Width_Int
	GuiControl, Enable%Coord_Enable%, split_Height_Int
	GuiControl, Enable%Coord_Enable%, split_WH_Always_Int
	GuiControl,                     , split_MinNormMax_Int, %tsplit_MinNormMax%
	GuiControl,                     , OpenTheWindow,  % Message_Get(1072)   ;%; Open window

	Return
	; Return %tsplit_MinNormMax%
;}
	; ----------------------------------------------------------------
mDropDownTitle_Make:

	If ( split_Title_NrInt = "" )
		mTitle_Number_Set( 1 )

	mDropDownTitle_Make_Save := AWNr_XRef_%split_Title_NrInt%

	tsplit_Title := 
	tsplit_Title_Str := A_TickCount "`n"
	tsplit_TitleIdx := 
	
	
	; --- arrange titles unsorted / A..Z / Z..A
	Loop, %AWNr_CntEntries%
	{

/*
		Temp_NrAW := A_Index
		If ( Titles_Sort_Basis )
		{
			If ( Titles_Sort_ZA )
				Temp_NrAW := A_Index
			Else
				Temp_NrAW := A_Index
				; Temp_NrAW := AWNr_CntEntries - A_Index + 1

		}
*/
		Temp_NrAW := AWNr_XRef_%A_Index%
		
		tsplit_TitleIdx .= Temp_NrAW "/ "
		; "** <Title of Window>  [Nr]"
		;------------------------------
		mWinSize2_StringSplit( Temp_NrAW )
		;------------------------------
		tsplit_Title .= "|"
			; msgbox tsplit_Title: %split_Comment_Text% :: %split_Title%
		If ( Titles_Sort_Basis AND ( Titles_Sort_wComm OR split_Comment_Use ) AND split_Comment_Text <> "" )
		{
			tsplit_Title .= split_Comment_Text "// " split_Title " "
		}
		Else
			tsplit_Title .= split_Title " "
		If ( Tooltip_Show_Numbers )
			tsplit_Title .= "  [" Temp_NrAW "]    "   ; A_Index
		If ( split_MatchMode = 2 )
		{
			tsplit_Title .= Message_Get(1111) " "   ; **
		}
		tsplit_Title_Str .= split_Title "  [" Temp_NrAW "]  "  A_Index "`n"
		
		; --- this is the actual position: mark it as active entry "||"
		If ( split_Title_NrAW_Demand > 0 )
		{
			If ( split_Title_NrAW_Demand = Temp_NrAW )   ; search for the org. slot nr.
			{
				tsplit_Title .= "|"
				mDropDownTitle_Make_Save := AWNr_XRef_%A_Index%
				split_Title_NrInt := A_Index
				; msgbox split_Title_NrAW_Demand: -%split_Title_NrAW_Demand%- -%A_Index%-`n%tsplit_Title%
			}
		}
		Else
		{
			If ( A_Index = split_Title_NrInt )  ; the slot nr of the
				tsplit_Title .= "|"
		}

		; last entry: append "||" or it will not be shown
		If ( A_Index = AWNr_CntEntries )
			tsplit_Title .= "|"
		; tsplit_Title .= "?"
	}
	
	split_Title_NrAW_Demand := 0
	
	; tsplit_Title_Length := StrLen( tsplit_Title )
	; Tooltip Length of tsplit_Title: %tsplit_Title_Length%

	/*
	;* AAAA
	If ( Tooltip_Show_Store )
	{
	TTL := 004
	TTLMsg := 
	TTLMsg := ATime() ":  (" TTL ") DropDownTitle:  " tsplit_Title_Str "`n"tsplit_Title
	TTLMsg := ATime() ":  (" TTL ") DropDownTitle:  " tsplit_Title_Str
	Tooltip_%TTL% := TTLMsg
	If ( Tooltip_Show_Tip = 1 )
	{
	CoordMode, ToolTip, Screen
	Tooltip %TTLMsg%  ,TTX , TTL*TTM, TTL+TTP ;%
	CoordMode, ToolTip, Relative
	}  }
	;* EEEE
	*/

	GuiControl,, split_Title_NrInt, %tsplit_Title%
	; MsgBox mDropDownTitle_Make %Titles_Sort_Basis% %Titles_Sort_ZA% `n"%tsplit_Title%
	
	;---------------------------------------------------
	; --- restore actual values
	mWinSize2_StringSplit( mDropDownTitle_Make_Save )
	; msgbox titel: "%AWNr_Array_1%" %split_X_Coord% %split_Y_Coord%
	;---------------------------------------------------

	Title_Number_Sort := split_Title_NrInt

	Return

	; ----------------------------------------
ButtonDelTooltip:
	Delete_All_Tooltips()

	Return

	; ----------------------------------------
; gButtonIconSave:
ButtonIconSave:
	mDesktop_Network_Start()
	mDesktopIconSave()
	mDesktop_Network_Ready()
	Return
	; ----------------------------------------
; gButtonIconRestore:
ButtonIconRestore:
	mDesktop_Network_Start()
	mDesktopIconRestore()
	mDesktop_Network_Ready()
	Return
	; ----------------------------------------
; gButtonIconChanged:
ButtonIconChanged:
	mDesktop_Network_Start()
	mDesktopIconChanged( )
	mDesktop_Network_Ready()
	Return
	
	; ----------------------------------------
; gButtonNetworkSave:
ButtonNetworkSave:
	mDesktop_Network_Start()
	mNetwork_Save()
	mNetwork_MakeFile()
	mDesktop_Network_Ready()
	Return
	; ----------------------------------------
; gButtonNetworkRestore:
ButtonNetworkRestore:
	mDesktop_Network_Start()
	mNetwork_Restore()
	mDesktop_Network_Ready()
	Return
	; ----------------------------------------
; gButtonNetworkChanged:
ButtonNetworkChanged:
	mDesktop_Network_Start()
	;mNetworkChanged( )
	mDesktop_Network_Ready()
	Return
	
	; ----------------------------------------
; gButtonNetworkDelete:
ButtonNetworkDelete:
	mDesktop_Network_Start()
	mNetwork_MakeFile()
	
	Gui +OwnDialogs
	; "?" 32   Yes/NO 4
	; *** (1166)  Delete file
	; *** (1171)  Do you want to delete file: 
	Text00 := Message_Get(1166)
	Text01 := Message_Get(1171) " " Network_File
	MsgBox 36, %Text00%, %Text01%
	; Text2Change: "%Text2Change%"
	IfMsgBox, Yes
	{
		FileDelete %Network_PathFile%
		Network_Error := ErrorLevel
		
		mNetwork_MakeFile()
		; *** (1167)  ... deleted:  Network_File
		; *** (1169)  *** Error deleting file: $
		; vButtonIconDoneTextRed
		If ( Network_Error = 0 )
		{
			GuiControl,       , ButtonIconDoneTextRed 
			GuiControl,       , ButtonIconDoneTextGreen , % Message_Get( 1167 ) " " Network_File  ;%; 
		}
		Else
		{
			; (X)
			; *** (1169)  *** Error deleting file: 
			Msgbox 16, % Message_Get(1166) , % Message_Get(1169) " " Network_PathFile
			GuiControl,       , ButtonIconDoneTextGreen
			GuiControl,       , ButtonIconDoneTextRed , % Message_Get( 1169 ) " " Network_File  ;%; 
		}
	}
	Else
	{
		; *** (1168)  Delete aborted.
		GuiControl,       , ButtonIconDoneTextGreen
		GuiControl,       , ButtonIconDoneTextRed , % Message_Get( 1168 )  ;%;
	}

	Return
	
	; ----------------------------------------
GuiClose:
GUIEscape:
	Gui, Submit, NoHide
	; msgbox GuiClose
	Goto ButtonAbort

	; ----------------------------------------
; --- if the user types "ESC" ..
; gButtonAbort:
ButtonAbort:
	If ( Disable_TickCount > A_TickCount )
		Return
	GoSub Text2Change_IsSet
	If ( Text2Change <> "" )
		Return
	mShowButton( "ButtonAbort" )
	; --- if user says "Yes, all lost"
	;     do not ask a second time
	IfMsgBox, Yes
	{
		mLogFile_Write( 1, "Button ""Abort""" )
	}
	Else
	{
		GoSub TextOK_IsSet
		If ( TextOK <> "" )
			Return
	}

		vGUI_TERMINATE_NOW := 10
	; msgbox ButtonAbort  %split_Title% / %split_X_Coord% / %split_Y_Coord% / %split_XY_Always% / %split_Width% / %split_Height% / %split_WH_Always% /  
	Goto Parameter_Destroy

	; ----------------------------------------
; gButtonOK:
ButtonOK:
	If ( Disable_TickCount > A_TickCount )
		Return
	Gui, Submit, NoHide
	vGUI_TERMINATE_NOW := 11
	mShowButton( "ButtonOK" )
	
	;  ************************** OK: do the changes **********
	; msgbox ButtonOK  %split_Title% / %split_X_Coord% / %split_Y_Coord% / %split_Width% / %split_Height%  
	GoSub FullScreen_Char_IsSet
	AWNr_Element_Make()

	mTray_Icon_Disable_SetTray()
	vWinSize2_Not_Active := vWinSize2_Not_Active_Int
	; msgbox mTray_Icon_Disable_SetTray  %vWinSize2_Not_Active%

	mLogFile_Write( 1, "Button ""OK"":     " AWNr_Element )
	; split_Title_NrAW := AWNr_XRef_%split_Title_NrInt%
	AWNr_%split_Title_NrAW% := AWNr_Element
	; msgbox AWNr_%split_Title_NrAW% = %AWNr_Element%

	If ( Sort_New )
	{
		split_Title_NrAW_Demand := split_Title_NrAW
		Sort_Titles()
	}
	Sort_New := 0
	
	vLanguage_INI := vLanguage_Nr_Name
	StringUpper, vLanguage_INI, vLanguage_INI
	vLanguage_NameLong := vLanguage_INI
	Message_Get( 1000 , 1 )  ; INIT to the message function

	If ( vLanguage_Nr_Name_Old <> vLanguage_Nr_Name )
	{
		mLanguage_Set( vLanguage_NameLong )
		; mLanguage_Set( vLanguage_Nr_Name )
	}

	mMenuTray()

	File_WinSize2_WriteDelete()
	mFullScreen_Update()
	mAWNr_Display()
	; msgbox ButtonOK:

	IniFile_Write_All := 1
	WinSize2_Exit_Now := Par_Exit_Now
	; msgbox WinSize2_Exit_Now: %WinSize2_Exit_Now%  %Par_Exit_Now%

Parameter_Destroy:
	WinGetPos, GuiWindowX, GuiWindowY, split_Width, split_Height, %GuiCaption%
	Gui Submit
	Gui Destroy   ; of "Special Parameter" window
	; msgbox GuiWindowX/Y: "%GuiWindowX%" "%GuiWindowY%"
	; msgbox Return  THE EXIT  %split_Title% / %split_X_Coord% / %split_Y_Coord% / %split_Width% / %split_Height%  
	; msgbox dir name %A_WorkingDir%\%vProgram_NNamExt%
	If ( StartWinChecked = 1 )
	{
		AScriptName = %A_WorkingDir%\%vProgram_NNamExt%
		WinSize2_Registry( 2, AScriptName )   ; Write to registry
		/*
		RegWrite REG_SZ
			, HKEY_LOCAL_MACHINE, Software\Microsoft\Windows\CurrentVersion\Run
			, WinSize2
			, %A_WorkingDir%\%vProgram_NNamExt%
		*/
	}
	Else
	{
		WinSize2_Registry( 3 )   ; Delete entry in registry
		/*
		RegDelete 
			, HKEY_LOCAL_MACHINE, Software\Microsoft\Windows\CurrentVersion\Run
			, WinSize2
		*/
	}

	If ( vCtrl_Alt_Y_Hotkey = "" )
		vCtrl_Alt_Y_Hotkey := vCtrl_Alt_Y_Hotkey_Old
	
	Title_NrInt_Last := split_Title_NrInt
	Delay_Show_Tooltip := Delay_Show_Tooltip_New

	; --- open last tab AND tab is changed
	; --- this tab-number is saved  even if you click Abort
	If ( TabNumber_ActTab_Old <> TabNumber_ActTab )
	{
		If ( TabNumber_Open_Last_Tab = 1 )
		{
			IniFile_Write_All := 1
		}
	}
	;=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
	Return	; THIS IS THE END MY FRIEND
	;=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*


}   ; END WinSize2_Parameter

/*
 **************************************************************
 *  SUB AWNr_Element_Make:
 */
AWNr_Element_Make()
{
	Global

	If ( split_Title = "" )
	{
		; split_Title_NrAW := 9999
		AWNr_Element :=
		; MSGBOX AWNr_Element_Make: AWNr_Element = empty
	}
	Else
	{
		If ( split_X_Coord = "" )
							split_X_Coord := 10
		If ( split_Y_Coord = "" )
							split_Y_Coord := 10
		If ( split_Width = "" )
							split_Width := 400
		If ( split_Height = "" )
							split_Height := 400

		; If ( split_MinNormMax_Int <> "" AND split_MinNormMax_Int <> 0 )
		;	split_MinNormMax := split_MinNormMax_Int
		; Tooltip split_Title "%split_Title%" old "%split_Title_Old%" match "%split_MatchMode%"
		If ( AWNr_Deleted )
		{
			AWNr_Element :=
			; MSGBOX AWNr_Element_Make 01
		}
		Else
		{
			; if not: keep what it was before: 2 or 3
			; if same title entry as before                AND title was changed
			If ( split_Title_NrInt_Old = split_Title_NrInt AND split_Title <> split_Title_Old )
			{
				; msgbox AWNr_Element_Make: split_Title_NrInt / %split_Title_NrInt% /%split_Title%
				split_MatchMode := 2  ; **Contained** in ...
				FullScreen_Text = %FullScreen_Text%`nungleich %split_Title_Old%  %split_Title%
				; mFullScreen_Replace( split_Title_Old, split_Title, split_FullScr_Sum )
				; mFullScreen_Display()
			}
			
			AWNr_Element :=     split_Title     CUT split_X_Coord   CUT split_Y_Coord     CUT split_Width
			AWNr_Element .= CUT split_Height    CUT split_MatchMode CUT split_AlwaysOnTop CUT split_Delay 
			AWNr_Element .= CUT split_XY_Always CUT split_WH_Always CUT split_MinNormMax  CUT split_AhkClass
			AWNr_Element .= CUT split_FullScr_Sum CUT split_Comment_Use CUT split_Comment_Text
			AWNr_Element .= CUT AA1
			; AWNr_Element := mWinSize2_StringMake()
			; MSGBOX AWNr_Element_Make: %AWNr_Element%
		}
		; split_Title_NrAW := AWNr_XRef_%A_Index%
		; msgbox AWNr_Element_Make: Nr. %split_Title_NrAW% %AWNr_Element%
	}
	Return
}

/*
 **************************************************************
 *  SUB mTitle_Number_Set:
 */
mTitle_Number_Set( Number )
{
	Global
	
	split_Title_NrInt := Number
	
	If ( split_Title_NrInt > AWNr_CntEntries )
		split_Title_NrInt := AWNr_CntEntries
	If ( split_Title_NrInt <= 0 )
		split_Title_NrInt := 1

	split_Title_NrAW := AWNr_XRef_%split_Title_NrInt%
	; tooltip split_Title_NrAW: %split_Title_NrAW%
}
	
/*
 **************************************************************
 *  SUB mTitle_Number_Get:
 * /
mTitle_Number_Get( Number )
{
	Global
	
	
	If ( Titles_Sort_Basis )
	{
		If ( Titles_Sort_ZA )
		{
			split_Title_NrAW := AWNr_XRef_%Number%
			Title_Number_Sort := Number
		}
		Else
		{
			split_Title_NrAW := AWNr_CntEntries - Number + 1
			Title_Number_Sort := Number
		}
		
	}
	Else
	{
		split_Title_NrAW := 9999
		Title_Number_Sort := Number
	}
	

			; split_Title_NrAW := AWNr_XRef_%Number%
			; Title_Number_Sort := Number
	mTitle_Number_XRefStr_Disp()
	
	Return
}

/*
 **************************************************************
 *  SUB mTitle_Number_XRefStr_Disp:
 */
mTitle_Number_XRefStr_Disp()
{
	Global
	
	XRef_Str =
	
	Loop, %AWNr_CntEntries%
	{
		XRef_Str .= " /"
		If ( A_Index = AWNr_XRef_%split_Title_NrInt% )
			XRef_Str .=  " > "
		XRef_Str .= A_Index ":" AWNr_XRef_%A_Index%
	}
	; msgbox mTitle_Number_Invers: %Number_AWNr% :: %XRef_Str%
	/*
	;* AAAA
	If ( Tooltip_Show_Store )
	{
	TTL := 003
	TTLMsg := 
	TTLMsg := ATime() ":  (" TTL ") DropDownTitle:  " split_Title_NrInt "/" split_Title_NrAW "  ::  " XRef_Str
	Tooltip_%TTL% := TTLMsg
	If ( Tooltip_Show_Tip = 1 )
	{
	CoordMode, ToolTip, Screen
	Tooltip %TTLMsg%  ,TTX , TTL*TTM, TTL+TTP ;%
	CoordMode, ToolTip, Relative
	}  }
	;* EEEE
	*/
	mAWNr_Display()   ; 005
	Return
}

/*
 **************************************************************
 *  search the sorted number in the XRef-array
 *  SUB mTitle_Number_Add:
 */
mTitle_Number_Add( Number )
{
	Global
	

	; mTitle_Number_Get( Number )
	split_Title_NrInt += Number
	If ( split_Title_NrInt < 1 )
	{
		split_Title_NrInt := Title_Number_Max

		;*** (1102)  ***  End of the List  ***
		Text := Message_Get( 1102 )
		Tooltip `n   %Text%   `n ,10,10
	}
	If ( split_Title_NrInt > Title_Number_Max )
	{
		split_Title_NrInt := 1
		
		;*** (1101)  ***  Head of the List  ***
		Text := Message_Get( 1101 )
		Tooltip `n   %Text%   `n ,10,10
	}
	mTitle_Number_Set( split_Title_NrInt )

	Title_Number_Old := 0
	Title_Number_Sort := split_Title_NrInt

	; GoSub mDropDownTitle_Make
	Return

}

/*
 **************************************************************
 *  SUB mTitle_Number_Invers:
 */
mTitle_Number_Invers( Number )
{
	Global
	
	mTitle_Number_XRefStr_Disp()
	
	Number_AWNr = 0
	
	Loop, %AWNr_CntEntries%
	{
		If ( AWNr_XRef_%A_Index% = Number )
			Number_AWNr := A_Index
	}
	
	If ( Number_AWNr = 0 )
		MsgBox `nmTitle_Number_Invers has not found the number:  "%Number%"
	
	Return Number_AWNr
}
/*
 **************************************************************
 *  SUB mShowButton:
 */
mShowButton( ButtonName )
{
	Global
	If ( Para_ShowButton_Enable <> 1 )
		Return

	Para_ShowButton_Text .= "`n" ButtonName
	; Tooltip Click on button: `n%Para_ShowButton_Text%
	Return
}
	
/*
 **************************************************************
 *  SUB ButtonChange_Enable:
 */
ButtonChange_Enable( En_Disable )
{
	Global
	
	If ( En_Disable = 1 )
	{
		If ( AWNr_Deleted = 0 )
		{
			Text2Change := Message_Get(1097)   ; !!!!!!
			TextOK_Mark := 1
			GuiControl,       , TextChange , %Text2Change%
			GuiControl, Enable, ButtonChange
			GuiControl, +Default, ButtonChange 

			;msgbox Text2Change 06a = %Text2Change%
			GuiControl, Enable, ButtonOK
		}
	}
	Else
	{
		; msgbox Text2Change 06b = %Text2Change%
		; Text2Change :=
		GuiControl,       , TextChange ,
		GuiControl, Enable0, ButtonChange
		GuiControl, +Default, ButtonAbort
	}
	Return
}

/*
 **************************************************************
 *  SUB WinSize2_Registry:
 */
WinSize2_Registry( Mode, RegEntry=0 )
 {
	; --- READ
	If ( Mode = 1 )
	{
		 RegRead RegEntry
			, HKEY_LOCAL_MACHINE
			, Software\Microsoft\Windows\CurrentVersion\Run
			, WinSize2
	}

	; --- WRITE
	Else If ( Mode = 2 )
	{
		RegWrite REG_SZ
			, HKEY_LOCAL_MACHINE
			, Software\Microsoft\Windows\CurrentVersion\Run
			, WinSize2
			, "%RegEntry%"
	}

	; --- DELETE
	Else If ( Mode = 3 )
	{
		RegDelete 
			, HKEY_LOCAL_MACHINE
			, Software\Microsoft\Windows\CurrentVersion\Run
			, WinSize2
		RegEntry =
	}
	Else
	{
		MsgBox WinSize2_Registry: unknown Mode=%Mode%
	}
		
	Return RegEntry
 }
/*
 **************************************************************
 *  SUB File_WinSize2_WriteDelete:
 */
File_WinSize2_WriteDelete()
{
	Global
	
	; vStart_WinSize2_Every_Dir
	If ( Start_WinSize2_Every_Dir_Old <> Start_WinSize2_Every_Dir )
	{
		If ( Start_WinSize2_Every_Dir )
		{
			FileDelete, %Start_WinSize2_PathFile%

			Text := A_ScriptDir "\" vProgram_NNam   ;%;
			Text  = "%Text%"
			Text := Text " %*"  ; % ;
FileAppend, 
(
Rem --- Batch file created automatically by: %A_ScriptName%
Rem     %A_YYYY%-%A_MM%-%A_DD%  %A_Hour%:%A_Min%
%Text%

) , %Start_WinSize2_PathFile%
			; *** (1032)  Start WinSize2 from every directory (CMD -> ..\System32)
			; *** (1092)  Error when writing the CMD file:
			; msgbox FileWrite  %Start_WinSize2_PathFile%
			If ( Errorlevel <> 0 )
				MsgBox, 16,, % "`nOption: " Message_Get(1032) "`n`n"  Message_Get(1092) "`n`n" Start_WinSize2_PathFile ;%;
		}
		Else
		{
			FileDelete, %Start_WinSize2_PathFile%
			; *** (1032)  Start WinSize2 from every directory (CMD -> ..\System32)
			; *** (1093)  Error deleting the CMD file:
			; msgbox FileDelete  %Start_WinSize2_PathFile%
			If ( Errorlevel <> 0 )
				MsgBox, 16,, % "`nOption: " Message_Get(1032) "`n`n"  Message_Get(1093) "`n`n" Start_WinSize2_PathFile ;%;
		}
		Start_WinSize2_Every_Dir_Old = Start_WinSize2_Every_Dir
	}
	Return
}

/*
 **************************************************************
 *  SUB mFullScreen_Update:
 */
mFullScreen_Update()
{
	Global
	
	; msgbox mFullScreen_Update:
	Loop, %AWNr_CntEntries%
	{
		mWinSize2_StringSplit( A_Index )
		If ( split_MinNormMax = 5 )  ; full screen
		{
			split_Title_Edit_Old := split_Title_Edit_Old_%A_Index%
			If ( split_Title_Edit_Old  <> "***" )
			{
				; If ( split_Title_Edit_Old  = "" )
				;	split_Title_Edit_Old := split_Title

				mFullScreen_Replace( split_Title_Edit_Old, split_Title, split_FullScr_Sum )
				split_Title_Edit_Old_%A_Index% = ***
			}
		}
	}
}

/*
 **************************************************************
 * SUB mLanguage_Set:
 */
mLanguage_Set( Language_Name_Long )
{
	Global

	/*
	RunText =%IniFile_Utils_CMD_Run% Language xx %Language_Name_Long%
	mLogFile_Write( 2, RunText )
	RunWait  %RunText% ,  , %RunWait_Min%
	*/
	mRunCheck( 2, IniFile_Utils_CMD_Run , " Language xx " Language_Name_Long )

}

/*
 **************************************************************
 *  SUB mLang_Select_All_Set:
 */
mLang_Select_All_Set()
{
	Global
	
	vLanguage_Nr           := 0
	vLanguage_ID           := 0
	vLanguage_DEFAULT_LONG := "???"
	vLanguage_DEFAULT_Nr   := 0
	vLanguage_DEFAULT_CHCP := 0
	vLanguage_Nr           := 0
	vLanguage_EN_Nr        := 0
	vLanguage_LAST_Nr      := 0
	vLang_Select_All       := "|"
	
	Nr := 2
	Dir := "..\"
	Dir :=
	
	/*
	Language     Decimal     Hex.    2-Dec
	Arabic          1025     0x0401      1
	Brazilian       1046     0x0416     22
	Chinese (Simpl) 2052     0x0804      4
	Chinese (Trad)  1028     0x0404      4
	Czech           1029     0x0405      5
	Danish          1030     0x0406      6
	Dutch           1043     0x0413     19
	English (Def)   1033     0x0409      9
	Finnish         1035     0x040B     11
	French          1036     0x040C     12
	German          1031     0x0407      7
	Greek           1032     0x0408      8
	Hebrew          1037     0x040D     13
	Hungarian       1038     0x040E     14
	Italian         1040     0x0410     16
	Japanese        1041     0x0411     17
	Korean          1042     0x0412     18
	Norwegian       1044     0x0414     20
	Polish          1045     0x0415     21
	Portuguese      2070     0x0816     22
	Russian         1049     0x0419     25
	Spanish         3082     0x0c0A     10
	Swedish         1053     0x041D     29
	Turkish         1055     0x041F     31
	*/
	; get default language from registry: DE = 0407
	RegRead, vLanguage_Reg_Hex, HKEY_LOCAL_MACHINE, SYSTEM\CurrentControlSet\Control\NLS\Language, Default

	; vLanguage_Reg_Hex=041D
	StringRight, vLanguage_Reg_Hex2, vLanguage_Reg_Hex, 2   ; get lang-id: "1D"
	vLanguage_Reg_Hex2 := "0x" vLanguage_Reg_Hex2   ; create hex-nr: "0x1D"
	vLanguage_Reg_Intg := vLanguage_Reg_Hex2 + 0   ; convert to decimal: "29"

	; --- as a test only that unkown langs are English
	;vLanguage_Reg_Intg := 23
	
	; loop through all files with "Lang_WinSize2_*.Msg"
	Loop %Dir%%vLang_File_ID%_*.Msg
	{
		; don't process files with length 0
		If ( A_LoopFileSize = 0 )
			Continue
		vLang_FileName_Len := StrLen( A_LoopFileName )
		vLang_FileName_Start := 15
		
		; get length and token from filename: e.g. "GERMAN"
		vLang_Token_Len := vLang_FileName_Len - vLang_FileName_Start - 3
		vLang_Token := SubStr( A_LoopFileName, vLang_FileName_Start, vLang_Token_Len )
		vLang_Token_%Nr% := vLang_Token
		DLN := Dir A_LoopFileName

		vLang_ID        := Message_Get_File( DLN, "Language", "WinLanguage_ID" )         ; "7"       "29"
		vLang_NameLong  := Message_Get_File( DLN, "Language", "WinLanguage_NameLocal" )  ; "Deutsch" "Svenska"
		vLang_NameShort := Message_Get_File( DLN, "Language", "WinLanguage" )            ; "DE"      "SV"
		vLang_CodePage  := Message_Get_File( DLN, "Language", "WinLanguage_CodePage" )   ; 1250      1252

		; --- The default language
		If ( vLang_ID = vLanguage_Reg_Intg )
		{
			vLanguage_DEFAULT_LONG  := vLang_Token
			vLanguage_DEFAULT_SHORT := vLang_NameShort
			vLanguage_DEFAULT_CHCP  := vLang_CodePage
			vLanguage_DEFAULT_ID    := vLang_ID
			vLanguage_DEFAULT_Nr    := Nr
		}
		; --- English
		If ( vLang_ID = 9 )
		{
			vLanguage_EN    := vLang_Token
			vLanguage_EN_ID := vLang_ID
			vLanguage_EN_Nr := Nr
		}
		vLanguage_LAST_LONG    := vLang_Token
		vLanguage_LAST_SHORT   := vLang_NameShort
		vLanguage_LAST_CHCP    := vLang_CodePage
		vLanguage_LAST_ID      := vLang_ID
		vLanguage_LAST_Nr      := Nr

		vLang_Name := vLang_Token
		
		Loop_Cnt := 6 - vLang_Token_Len
		Loop , %Loop_Cnt%
		{
			vLang_Name .= " "
		}
		If ( vLang_NameLong <> "" )
			vLang_Name .= " - " vLang_NameLong
		vLang_Select_All .= vLang_Name "|"
		
		; mark the default language
		If ( vLanguage_INI = "?" OR vLanguage_INI = "" )
		{
			If ( vLang_ID = vLanguage_Reg_Intg )
			{
				vLanguage_NameLong  := vLang_Token
				vLanguage_NameShort := vLang_NameShort
				vLanguage_CodePage  := vLang_CodePage
				vLanguage_Nr        := Nr
				vLanguage_ID        := vLang_ID
				; msgbox %Nr%. Name??: %vLang_FileName_Len% "%A_LoopFileName%"   "%vLanguage_INI%" "%vLang_Token%"    "%vLang_NameLong%" --%vLang_Name%--
			}
		}
		Else If ( vLanguage_INI = vLang_Token )
		{
			vLang_Select_All    .= "|"
			vLanguage_NameLong  := vLang_Token
			vLanguage_NameShort := vLang_NameShort
			vLanguage_CodePage  := vLang_CodePage
			vLanguage_Nr        := Nr        ; no. of the lang-file in dir
			vLanguage_ID        := vLang_ID  ; "7" for German
		; msgbox %Nr%. Name: %vLang_FileName_Len% "%A_LoopFileName%"   "%vLanguage_INI%" "%vLang_Token%"    "%vLang_NameLong%" --%vLang_Name%--
		}
		; msgbox %vLanguage_INI%  mLang_Select_All_Set: %A_LoopFileName%   %vLang_Token%`n%vLang_NameLong%`n%vLang_NameShort%

		Nr += 1
	}

	;msgbox 01 vLanguage_Nr %vLanguage_NameLong%  "%vLanguage_Nr%"  "%vLanguage_ID%" 
	If ( vLanguage_Nr = 0 )
	{
		vLanguage_NameLong  := vLanguage_DEFAULT_LONG
		vLanguage_NameShort := vLanguage_DEFAULT_SHORT
		vLanguage_CodePage  := vLanguage_DEFAULT_CHCP
		vLanguage_Nr        := vLanguage_DEFAULT_Nr
		vLanguage_ID        := vLanguage_DEFAULT_ID
	}
	If ( vLanguage_Nr = 0 )
	{
		vLanguage_NameLong  := vLanguage_EN
		vLanguage_CodePage  := 850
		vLanguage_Nr        := vLanguage_EN_Nr
		vLanguage_ID        := vLanguage_EN_ID
	}
	If ( vLanguage_Nr = 0 )
	{
		vLanguage_NameLong  := vLanguage_LAST_LONG
		vLanguage_NameShort := vLanguage_LAST_SHORT
		vLanguage_CodePage  := vLanguage_LAST_CHCP
		vLanguage_Nr        := vLanguage_LAST_Nr
		vLanguage_ID        := vLanguage_LAST_ID
	}
	;msgbox 04 vLanguage_Nr %vLanguage_NameLong%  "%vLanguage_Nr%"  "%vLanguage_ID%" 
	;  (1118)   "?  default:"
	vLang_Select_All := Message_Get(1118) " " vLanguage_DEFAULT_LONG "|" vLang_Select_All

	IniFile_Utils_CMD := "WS2_Utils.cmd"
	IniFile_Utils_CMD_Temp := Temp "\" IniFile_Utils_CMD
	; IniFile_Utils_CMD_Run := "cmd.exe /c ChCp " vLanguage_CodePage "&& " IniFile_Utils_CMD
	IniFile_Utils_CMD_Run := IniFile_Utils_CMD

}

/*
 **************************************************************
 * gButtonIconSave:
 * SUB mDesktopIconSave:
 */
mDesktopIconSave( File=0 )
{
	Global
	Start_Desktop := 1
	
	If ( File = 0 )
		File = %IniFile_PathFile_DesktopIcon_DTR%
	
	; http://www.midiox.com/desktoprestore.htm
	mDesktopIconCreateFile( "Save" )   ; 1
	; start the CMD command file
	/*
	RunText =%IniFile_Utils_CMD_Run% Desktop Save  %Screen_Width_Height%
	mLogFile_Write( 2, RunText )
	RunWait  %RunText% ,  , %RunWait_Min%
	*/
	mRunCheck( 2, IniFile_Utils_CMD_Run , " Desktop Save " Screen_Width_Height )
	; msgbox  "%IniFile_Utils_CMD_Run%"  ErrorLevel: %ErrorLevel%
	
	Desktop_Network_Ready_Error := ErrorLevel
	Desktop_Network_Ready_File := IniFile_Utils_CMD
	; msgbox mDesktopIconSave %File%
	mLogFile_Write( 2, "DesktopIcon Save " File )
	
	If ( Network_WithIconSave )
		mNetwork_Save()
	
	Return
}
	
/*
 **************************************************************
 * gButtonIconRestore:
 * SUB mDesktopIconRestore:
 */
mDesktopIconRestore()
{
	Global
	Start_Desktop := 1
	
	; http://www.midiox.com/desktoprestore.htm
	mDesktopIconCreateFile( "Restore" )   ; 2
	/*
	; start the CMD command file
	RunText =%IniFile_Utils_CMD_Run% Desktop Restore  %Screen_Width_Height%
	mLogFile_Write( 2, RunText )
	RunWait  %RunText% ,  , %RunWait_Min%
	*/
	mRunCheck( 2, IniFile_Utils_CMD_Run , " Desktop Restore " Screen_Width_Height )

	Desktop_Network_Ready_Error := ErrorLevel
	Desktop_Network_Ready_File := IniFile_Utils_CMD
	
	If ( Network_WithIconRestore )
		mNetwork_Restore()
	
	Return
}

/*
 **************************************************************
 * gButtonIconChanged:
 * SUB mDesktopIconChanged:
 */
mDesktopIconChanged( )
{
	Global
	
	mDesktopIconCreateFile( "Check" )
	/*
	RunText =%IniFile_Utils_CMD_Run% Desktop Check  %Screen_Width_Height%
	mLogFile_Write( 2, RunText )
	RunWait  %RunText% ,  , %RunWait_Min%
	*/
	mRunCheck( 2, IniFile_Utils_CMD_Run , " Desktop Check " Screen_Width_Height )

	Desktop_Network_Ready_Error := ErrorLevel
	Desktop_Network_Ready_File := IniFile_Utils_CMD

	Return
}
/*
 **************************************************************
 * SUB mDesktopIconChanged_NoOK:
 */
mDesktopIconChanged_NoOK( )
{
	Global
	
	FileGetSize IniFile_PathFile_DesktopIcon_DTR_Size , %IniFile_PathFile_DesktopIcon_DTR%
	If ( IniFile_PathFile_DesktopIcon_DTR_Size <= 10 
		AND FileExist( IniFile_PathFile_DesktopIcon_DTR ) )
	{
		RunText =Desktop icons are not to be checked: %Screen_Width_Height%
		GuiControl,       , ButtonIconDoneTextGreen
		GuiControl,       , ButtonIconDoneTextRed   , % RunText  ;%; 
	}
	Else
	{
		mDesktopIconCreateFile( "CheckNoBox" )
		/*
		RunText =%IniFile_Utils_CMD_Run% Desktop CheckNoBox  %Screen_Width_Height%
		RunWait  %RunText% ,  , %RunWait_Min%
		mLogFile_Write( 2, RunText )
		*/
		mRunCheck( 2, IniFile_Utils_CMD_Run , " Desktop CheckNoBox " Screen_Width_Height )
	}
	Desktop_Network_Ready_Error := ErrorLevel
	Desktop_Network_Ready_File := IniFile_Utils_CMD

	Return
}
/*
 **************************************************************
 * SUB mDesktop_Network_Start:
 */
mDesktop_Network_Start()
{
	Global

	DesktopIcon_CheckAfterLogin_DOS := 15
	; msgbox IniFile_Utils_CMD_Run %IniFile_Utils_CMD_Run%
	
	Start_Desktop := 0
	Start_Network := 0

	; *** (1140)  ... executing
	; vButtonIconDoneTextRed
	GuiControl,       , ButtonIconDoneTextGreen
	GuiControl,       , ButtonIconDoneTextRed , % Message_Get( 1140 ) ;%;
}

/*
 **************************************************************
 * SUB mDesktop_Network_Ready:
 */
mDesktop_Network_Ready( )
{
	Global
	
	File :=
	If ( Start_Desktop = 1 )
		File := "  """ IniFile_File_DesktopIcon """  "
	
	If ( Start_Network = 1 )
	{
		If ( File <> "" )
			File .= " + "
		File .= "  """ Desktop_Network_Ready_File """ "
		; File .= "  """ IniFile_File_Network """ "
	}
	; msgbox  %Start_Desktop%  %IniFile_File_DesktopIcon%  `n%Start_Network%  %IniFile_File_Network%
	; *** (1151)  ... done:  File1 + File2
	; vButtonIconDoneTextRed
	If ( Desktop_Network_Ready_Error = 0 OR Desktop_Network_Ready_Error = 100 )
	{
		If ( Desktop_Network_Ready_Error = 100 )
		{
			LogText = CheckIcons deleted for %Screen_Width_Height%
			mLogFile_Write( 2, LogText )
		}
		GuiControl,       , ButtonIconDoneTextRed
		GuiControl,       , ButtonIconDoneTextGreen , % Message_Get( 1151 ) " " File  ;%; 
		; MsgBox % Message_Get( 1151 ) " " File  ;%; 
	}
	Else
	{
		GuiControl,       , ButtonIconDoneTextGreen
		GuiControl,       , ButtonIconDoneTextRed   , % Message_Get( 1153 ) " " File  ;%; 
		
		Gui +OwnDialogs
		; "!" Yes/NO
		; *** (1154)  Error processing file
		Text00 := Message_Get(1154)
		Text01 := Desktop_Network_Ready_File
		MsgBox 16, %Text00%, %Text01%   ; Error (X)
	}
}
/*
 **************************************************************
 * SUB mNetwork_Save:
 */
mNetwork_Save( )
{
	Global
	Start_Network := 1
	mNetwork_MakeFile()

	; FileAppend [, Text, Filename]
	FileAppend ,  xx , %Network_PathFile%
	; Msgbox FileAppend  %Network_PathFile%

	mNetwork_MakeFile()
	
	; start the CMD command file:      P1     P2     P3
	/*
	RunText =%IniFile_Utils_CMD_Run% Network Save "%Network_PathFile%"
	mLogFile_Write( 2, RunText )
	RunWait  %RunText% ,  , %RunWait_Min%
	*/
	mRunCheck( 2, IniFile_Utils_CMD_Run , " Network Save " Network_PathFile )

	Desktop_Network_Ready_Error := ErrorLevel
	Desktop_Network_Ready_File := Network_File

	mLogFile_Write( 2, command )
	
	Return
}
	
/*
 **************************************************************
 * SUB mNetwork_Restore:
 */
mNetwork_Restore()
{
	Global
	mNetwork_MakeFile()

	If ( Network_ID_ScreenWHExist )
	IfExist %Network_PathFile%
	{
		Start_Network := 1
		
		; start the CMD command file
		/*
		RunText =%IniFile_Utils_CMD_Run% Network Restore "%Network_PathFile%"
		mLogFile_Write( 2, RunText )
		RunWait  %RunText% ,  , %RunWait_Min%
		*/
		mRunCheck( 2, IniFile_Utils_CMD_Run , " Network Restore " Network_PathFile )

		Desktop_Network_Ready_Error := ErrorLevel
		Desktop_Network_Ready_File := Network_File

		; mLogFile_Write( 2, command )
	}
	Else
	{
		command :=  "*** LAN_Restore, but file does not exist """ Network_PathFile """"
		mLogFile_Write( 2, command )
	}
	
	Return
}

/*
 **************************************************************
 * SUB mNetwork_MakeFile:
 */
mNetwork_MakeFile( Mode=1 )
{
	Global
	
	; if 'not exist' mark "? <resolution>": return "<resolution>"
	If ( SubStr( Network_ID_Select , 1 , 2 ) = "? " )
		Network_ID_Select := SubStr( Network_ID_Select , 3 )

	If ( Network_ID_Select = "" )
		Network_ID_Select := Screen_Width_Height
	
	Network_ID_All :=
	Network_ID_ScreenWHExist := 0
	Network_ID_SelectExist := 0
	Network_Restore_Disable := 1
	
	; WinSize2_Network_<Network_ID>.NSH
	Loop %IniFile_Path%\%IniFile_File_Network_0%*
	{
		; NewStr := SubStr(String, StartPos [, Length]) 
		Network_Start := StrLen( IniFile_File_Network_0 ) + 1
		Network_Len := StrLen( A_LoopFileName ) - Network_Start - 3 
		Network_ID := SubStr( A_LoopFileName , Network_Start , Network_Len )
		Network_ID_%A_Index% := Network_ID
		Network_ID_All .= Network_ID "|"
		If ( Network_ID = Screen_Width_Height )
		{
			Network_ID_ScreenWHExist := 1
			Network_ID_SelectExist := 1
			Network_ID_All .= "|"
		}
		If ( Network_ID = Network_ID_Select )
		{
			Network_ID_SelectExist := 1
			Network_Restore_Disable := 0
			Network_ID_All .= "|"
		}
		; msgbox %Network_ID_All%  %Network_Start%  %Network_Len%
		; Network_ID_All .= SubStr( A_LoopFileName , StrLen( %IniFile_File_Network_0% ) , StrLen( %A_LoopFileName% ) - 4 ) "|"
	}
	; the actual screen resolution was not included
	If ( Network_ID_ScreenWHExist )
	{
		Network_Restore_Disable := 0
	}
	Else
	{
		Network_ID_All .= "? " Screen_Width_Height
		If ( Network_ID_SelectExist )
			Network_ID_All .= "|"
		Else
		{
			Network_ID_All .= "||"
		}
		Network_ID_ScreenWHExist := Screen_Width_Height
	}

	; If ( Network_Restore_Disable )
	IfExist %Network_PathFile%
		Network_Restore_Caption := Message_Get( 1163 )   ; Restore network settings
	Else
		Network_Restore_Caption := Message_Get( 1170 )   ; Restore - file does not exist
	GuiControl, Disabled%Network_Restore_Disable%, ButtonNetworkDelete
	GuiControl, Disabled%Network_Restore_Disable%, Network_Restore
	GuiControl,                                  , Network_Restore   , %Network_Restore_Caption%
	If ( Mode = 1 )
	GuiControl,                                  , Network_ID_Select , |%Network_ID_All%

	Network_File := IniFile_File_Network_0   Network_ID_Select ".NSH"
	Network_PathFile := IniFile_Path "\" Network_File

	; ListVars
	; Msgbox network files: %Network_ID_Select%(%Network_Restore_Disable%) ::%Network_ID_All%  ::%Network_Restore_Caption% 
	
}

/*
 **************************************************************
 * SUB mDesktopIconCreateFile:
 */
mDesktopIconCreateFile( Para1="Save" )
{
/*
 *   Para1=1:  Save Postitions
 *   Para1=2:  Restore Postitions
 *   Para1=3:  Search for changed Positions - show box if nothing was changed
 *   Para1=4:  Search for changed Positions - dont show box if nothing was changed
 */

	Global
	Start_Desktop := 1
	mNetwork_MakeFile()

	/*
	; *** (DesktopIcon001)  Desktop Icons
	; *** (DesktopIcon002)  Some icon positions have been changed ^or ^there are new icons on the desktop.
	; *** (DesktopIcon003)  ^^Click here [O] to stop the timer.
	; *** (DesktopIcon004)  Save;Restore;Quit -$-
	; *** (DesktopIcon005)  Icons are not changed.
	; *** (DesktopIcon006)  Quit -$-
	Desktop_WBox_Caption      := Message_Get( "DesktopIcon001" )
	Desktop_WBox_TextChange   := Message_Get( "DesktopIcon002" )  Message_Get( "DesktopIcon003" )
	Desktop_WBox_Buttons3     := Message_Get( "DesktopIcon004" )
	Desktop_WBox_TextNoChange := Message_Get( "DesktopIcon005" )
	Desktop_WBox_Buttons1     := Message_Get( "DesktopIcon006" )

	; *** (DesktopIcon007)  Utility not accessable: 
	; *** (DesktopIcon008)  WinSize2: ERROR
	Desktop_WBox_ErrUtil      := Message_Get( "DesktopIcon007" )
	Desktop_WBox_ErrTitle     := Message_Get( "DesktopIcon008" )

	Desktop_WBox_ButtonsWidth := Message_Get( 1152 )
	*/
	
; --------------- set up the DOS CMD-File ---------------
;              %Temp%\WS2_Utils.cmd
	FileDelete %IniFile_Utils_CMD_Temp%
	FileAppend, 
	(
Rem ============================ Start %IniFile_Utils_CMD_Temp% ============================

Rem ---  %vProgram_NNam% wrote this file
Rem      to -Temp-
Rem ---  %A_Year%-%A_MM%-%A_DD%  %A_Hour%:%A_Min%

Set IniFile_File_DesktopIcon=%IniFile_File_DesktopIcon%
Set IniFile_File_DesktopIcon_DTR=%IniFile_File_DesktopIcon_DTR%
Set IniFile_File_DesktopIcon_NEW=%IniFile_File_DesktopIcon_NEW%
Set IniFile_PathFile_DesktopIcon_DTR=%IniFile_PathFile_DesktopIcon_DTR%
Set IniFile_PathFile_DesktopIcon_NEW=%IniFile_PathFile_DesktopIcon_NEW%

Set Network_WithIconSave=%Network_WithIconSave%
Set Network_WithIconRestore=%Network_WithIconRestore%

Set Network_PathFile=%Network_PathFile%
Set LogFile_PathFile=%LogFile_PathFile%
Rem ============================ End %IniFile_Utils_CMD_Temp% ============================
Exit /B 0

	) , %IniFile_Utils_CMD_Temp%
; --------------- END of DOS CMD-File ---------------

	Return
}

/*
 **************************************************************
 SUB mDesktopIcon_Disable:
 */
 mDesktopIcon_Disable()
{
	Global

	DesktopIcon_AutoRestore := ChkLogical( DesktopIcon_AutoRestore )

	GuiControl, Disable%DesktopIcon_AutoRestore%, DesktopIcon_CheckAfterLogin
	If ( DesktopIcon_AutoRestore = 0 )
	{
		GuiControl, Enable1, DesktopIcon_CheckAfterLogin
		; GuiControl, Enable%DesktopIcon_CheckAfterLogin%, DesktopIcon_CheckAfterLogin

		DesktopIcon_CheckAfterLogin_Once := DesktopIcon_CheckAfterLogin
		If ( DesktopIcon_CheckAfterLogin = 0 )
			DesktopIcon_CheckAfterLogin_Once := 0
	}
	Else
	{
		DesktopIcon_CheckAfterLogin_Once := 0
	}
}
/*
 **************************************************************
 */